<?php



/**
 * This class defines the structure of the 'lohnabrechnung' table.
 *
 *
 *
 * This map class is used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    propel.generator.propel.map
 */
class LohnabrechnungTableMap extends TableMap
{

    /**
     * The (dot-path) name of this class
     */
    const CLASS_NAME = 'propel.map.LohnabrechnungTableMap';

    /**
     * Initialize the table attributes, columns and validators
     * Relations are not initialized by this method since they are lazy loaded
     *
     * @return void
     * @throws PropelException
     */
    public function initialize()
    {
        // attributes
        $this->setName('lohnabrechnung');
        $this->setPhpName('Lohnabrechnung');
        $this->setClassname('Lohnabrechnung');
        $this->setPackage('propel');
        $this->setUseIdGenerator(true);
        $this->setSingleTableInheritance(true);
        // columns
        $this->addPrimaryKey('id', 'Id', 'INTEGER', true, null, null);
        $this->addColumn('mod', 'Mod', 'INTEGER', true, null, null);
        $this->addColumn('monat', 'Monat', 'CHAR', true, 6, null);
        $this->addColumn('arbeitsstunden', 'Arbeitsstunden', 'NUMERIC', true, 10, 0);
        $this->addColumn('brutto', 'Brutto', 'NUMERIC', true, 10, 0);
        $this->addColumn('zulage', 'Zulage', 'NUMERIC', true, 10, 0);
        $this->addColumn('netto', 'Netto', 'NUMERIC', true, 10, 0);
        $this->addColumn('lohnsteuer', 'Lohnsteuer', 'NUMERIC', true, 10, 0);
        $this->addColumn('kirchensteuer_rk', 'KirchensteuerRk', 'DECIMAL', true, 10, 0);
        $this->addColumn('kirchensteuer_ev', 'KirchensteuerEv', 'NUMERIC', true, 10, 0);
        $this->addColumn('soli', 'Soli', 'NUMERIC', true, 10, 0);
        $this->addColumn('rentenversicherung', 'Rentenversicherung', 'NUMERIC', true, 10, 0);
        $this->addColumn('krankenversicherung', 'Krankenversicherung', 'NUMERIC', true, 10, 0);
        $this->addForeignKey('ma_id', 'MaId', 'INTEGER', 'mitarbeiter', 'id', true, null, null);
        $this->addForeignKey('lp_id', 'LpId', 'INTEGER', 'lohnprofil', 'id', true, null, null);
        $this->addColumn('class_key', 'ClassKey', 'INTEGER', false, null, null);
        // validators
    } // initialize()

    /**
     * Build the RelationMap objects for this table relationships
     */
    public function buildRelations()
    {
        $this->addRelation('Mitarbeiter', 'Mitarbeiter', RelationMap::MANY_TO_ONE, array('ma_id' => 'id', ), null, null);
        $this->addRelation('Lohnprofil', 'Lohnprofil', RelationMap::MANY_TO_ONE, array('lp_id' => 'id', ), null, null);
    } // buildRelations()

} // LohnabrechnungTableMap
