<?php


/**
 * Base class that represents a row from the 'arbeitgeberbtr' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseArbeitgeberbtr extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'ArbeitgeberbtrPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        ArbeitgeberbtrPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the monat field.
     * @var        string
     */
    protected $monat;

    /**
     * The value for the rentenversicherung field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $rentenversicherung;

    /**
     * The value for the krankenversicherung field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $krankenversicherung;

    /**
     * The value for the u1 field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $u1;

    /**
     * The value for the u2 field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $u2;

    /**
     * The value for the inso field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $inso;

    /**
     * The value for the pauschalsteuer field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $pauschalsteuer;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->rentenversicherung = 0.0;
        $this->krankenversicherung = 0.0;
        $this->u1 = 0.0;
        $this->u2 = 0.0;
        $this->inso = 0.0;
        $this->pauschalsteuer = 0.0;
    }

    /**
     * Initializes internal state of BaseArbeitgeberbtr object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [monat] column value.
     *
     * @return string
     */
    public function getMonat()
    {

        return $this->monat;
    }

    /**
     * Get the [rentenversicherung] column value.
     *
     * @return double
     */
    public function getRentenversicherung()
    {

        return $this->rentenversicherung;
    }

    /**
     * Get the [krankenversicherung] column value.
     *
     * @return double
     */
    public function getKrankenversicherung()
    {

        return $this->krankenversicherung;
    }

    /**
     * Get the [u1] column value.
     *
     * @return double
     */
    public function getU1()
    {

        return $this->u1;
    }

    /**
     * Get the [u2] column value.
     *
     * @return double
     */
    public function getU2()
    {

        return $this->u2;
    }

    /**
     * Get the [inso] column value.
     *
     * @return double
     */
    public function getInso()
    {

        return $this->inso;
    }

    /**
     * Get the [pauschalsteuer] column value.
     *
     * @return double
     */
    public function getPauschalsteuer()
    {

        return $this->pauschalsteuer;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [monat] column.
     *
     * @param  string $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setMonat($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->monat !== $v) {
            $this->monat = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::MONAT;
        }


        return $this;
    } // setMonat()

    /**
     * Set the value of [rentenversicherung] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setRentenversicherung($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->rentenversicherung !== $v) {
            $this->rentenversicherung = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::RENTENVERSICHERUNG;
        }


        return $this;
    } // setRentenversicherung()

    /**
     * Set the value of [krankenversicherung] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setKrankenversicherung($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->krankenversicherung !== $v) {
            $this->krankenversicherung = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::KRANKENVERSICHERUNG;
        }


        return $this;
    } // setKrankenversicherung()

    /**
     * Set the value of [u1] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setU1($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->u1 !== $v) {
            $this->u1 = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::U1;
        }


        return $this;
    } // setU1()

    /**
     * Set the value of [u2] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setU2($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->u2 !== $v) {
            $this->u2 = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::U2;
        }


        return $this;
    } // setU2()

    /**
     * Set the value of [inso] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setInso($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->inso !== $v) {
            $this->inso = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::INSO;
        }


        return $this;
    } // setInso()

    /**
     * Set the value of [pauschalsteuer] column.
     *
     * @param  double $v new value
     * @return Arbeitgeberbtr The current object (for fluent API support)
     */
    public function setPauschalsteuer($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->pauschalsteuer !== $v) {
            $this->pauschalsteuer = $v;
            $this->modifiedColumns[] = ArbeitgeberbtrPeer::PAUSCHALSTEUER;
        }


        return $this;
    } // setPauschalsteuer()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->rentenversicherung !== 0.0) {
                return false;
            }

            if ($this->krankenversicherung !== 0.0) {
                return false;
            }

            if ($this->u1 !== 0.0) {
                return false;
            }

            if ($this->u2 !== 0.0) {
                return false;
            }

            if ($this->inso !== 0.0) {
                return false;
            }

            if ($this->pauschalsteuer !== 0.0) {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->monat = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->rentenversicherung = ($row[$startcol + 3] !== null) ? (double) $row[$startcol + 3] : null;
            $this->krankenversicherung = ($row[$startcol + 4] !== null) ? (double) $row[$startcol + 4] : null;
            $this->u1 = ($row[$startcol + 5] !== null) ? (double) $row[$startcol + 5] : null;
            $this->u2 = ($row[$startcol + 6] !== null) ? (double) $row[$startcol + 6] : null;
            $this->inso = ($row[$startcol + 7] !== null) ? (double) $row[$startcol + 7] : null;
            $this->pauschalsteuer = ($row[$startcol + 8] !== null) ? (double) $row[$startcol + 8] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 9; // 9 = ArbeitgeberbtrPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating Arbeitgeberbtr object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(ArbeitgeberbtrPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = ArbeitgeberbtrPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(ArbeitgeberbtrPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = ArbeitgeberbtrQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(ArbeitgeberbtrPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                ArbeitgeberbtrPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = ArbeitgeberbtrPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . ArbeitgeberbtrPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(ArbeitgeberbtrPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::MONAT)) {
            $modifiedColumns[':p' . $index++]  = '`monat`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::RENTENVERSICHERUNG)) {
            $modifiedColumns[':p' . $index++]  = '`rentenversicherung`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG)) {
            $modifiedColumns[':p' . $index++]  = '`krankenversicherung`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::U1)) {
            $modifiedColumns[':p' . $index++]  = '`u1`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::U2)) {
            $modifiedColumns[':p' . $index++]  = '`u2`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::INSO)) {
            $modifiedColumns[':p' . $index++]  = '`inso`';
        }
        if ($this->isColumnModified(ArbeitgeberbtrPeer::PAUSCHALSTEUER)) {
            $modifiedColumns[':p' . $index++]  = '`pauschalsteuer`';
        }

        $sql = sprintf(
            'INSERT INTO `arbeitgeberbtr` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`monat`':
                        $stmt->bindValue($identifier, $this->monat, PDO::PARAM_STR);
                        break;
                    case '`rentenversicherung`':
                        $stmt->bindValue($identifier, $this->rentenversicherung, PDO::PARAM_STR);
                        break;
                    case '`krankenversicherung`':
                        $stmt->bindValue($identifier, $this->krankenversicherung, PDO::PARAM_STR);
                        break;
                    case '`u1`':
                        $stmt->bindValue($identifier, $this->u1, PDO::PARAM_STR);
                        break;
                    case '`u2`':
                        $stmt->bindValue($identifier, $this->u2, PDO::PARAM_STR);
                        break;
                    case '`inso`':
                        $stmt->bindValue($identifier, $this->inso, PDO::PARAM_STR);
                        break;
                    case '`pauschalsteuer`':
                        $stmt->bindValue($identifier, $this->pauschalsteuer, PDO::PARAM_STR);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = ArbeitgeberbtrPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }



            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = ArbeitgeberbtrPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getMonat();
                break;
            case 3:
                return $this->getRentenversicherung();
                break;
            case 4:
                return $this->getKrankenversicherung();
                break;
            case 5:
                return $this->getU1();
                break;
            case 6:
                return $this->getU2();
                break;
            case 7:
                return $this->getInso();
                break;
            case 8:
                return $this->getPauschalsteuer();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array())
    {
        if (isset($alreadyDumpedObjects['Arbeitgeberbtr'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['Arbeitgeberbtr'][$this->getPrimaryKey()] = true;
        $keys = ArbeitgeberbtrPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getMonat(),
            $keys[3] => $this->getRentenversicherung(),
            $keys[4] => $this->getKrankenversicherung(),
            $keys[5] => $this->getU1(),
            $keys[6] => $this->getU2(),
            $keys[7] => $this->getInso(),
            $keys[8] => $this->getPauschalsteuer(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }


        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = ArbeitgeberbtrPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setMonat($value);
                break;
            case 3:
                $this->setRentenversicherung($value);
                break;
            case 4:
                $this->setKrankenversicherung($value);
                break;
            case 5:
                $this->setU1($value);
                break;
            case 6:
                $this->setU2($value);
                break;
            case 7:
                $this->setInso($value);
                break;
            case 8:
                $this->setPauschalsteuer($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = ArbeitgeberbtrPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setMonat($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setRentenversicherung($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setKrankenversicherung($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setU1($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setU2($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setInso($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setPauschalsteuer($arr[$keys[8]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(ArbeitgeberbtrPeer::DATABASE_NAME);

        if ($this->isColumnModified(ArbeitgeberbtrPeer::ID)) $criteria->add(ArbeitgeberbtrPeer::ID, $this->id);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::MOD)) $criteria->add(ArbeitgeberbtrPeer::MOD, $this->mod);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::MONAT)) $criteria->add(ArbeitgeberbtrPeer::MONAT, $this->monat);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::RENTENVERSICHERUNG)) $criteria->add(ArbeitgeberbtrPeer::RENTENVERSICHERUNG, $this->rentenversicherung);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG)) $criteria->add(ArbeitgeberbtrPeer::KRANKENVERSICHERUNG, $this->krankenversicherung);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::U1)) $criteria->add(ArbeitgeberbtrPeer::U1, $this->u1);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::U2)) $criteria->add(ArbeitgeberbtrPeer::U2, $this->u2);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::INSO)) $criteria->add(ArbeitgeberbtrPeer::INSO, $this->inso);
        if ($this->isColumnModified(ArbeitgeberbtrPeer::PAUSCHALSTEUER)) $criteria->add(ArbeitgeberbtrPeer::PAUSCHALSTEUER, $this->pauschalsteuer);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(ArbeitgeberbtrPeer::DATABASE_NAME);
        $criteria->add(ArbeitgeberbtrPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of Arbeitgeberbtr (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setMonat($this->getMonat());
        $copyObj->setRentenversicherung($this->getRentenversicherung());
        $copyObj->setKrankenversicherung($this->getKrankenversicherung());
        $copyObj->setU1($this->getU1());
        $copyObj->setU2($this->getU2());
        $copyObj->setInso($this->getInso());
        $copyObj->setPauschalsteuer($this->getPauschalsteuer());
        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return Arbeitgeberbtr Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return ArbeitgeberbtrPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new ArbeitgeberbtrPeer();
        }

        return self::$peer;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->monat = null;
        $this->rentenversicherung = null;
        $this->krankenversicherung = null;
        $this->u1 = null;
        $this->u2 = null;
        $this->inso = null;
        $this->pauschalsteuer = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(ArbeitgeberbtrPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
