<?php


/**
 * Base class that represents a row from the 'lohnabrechnung' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseLohnabrechnung extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'LohnabrechnungPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        LohnabrechnungPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the monat field.
     * @var        string
     */
    protected $monat;

    /**
     * The value for the arbeitsstunden field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $arbeitsstunden;

    /**
     * The value for the brutto field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $brutto;

    /**
     * The value for the zulage field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $zulage;

    /**
     * The value for the netto field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $netto;

    /**
     * The value for the lohnsteuer field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $lohnsteuer;

    /**
     * The value for the kirchensteuer_rk field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $kirchensteuer_rk;

    /**
     * The value for the kirchensteuer_ev field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $kirchensteuer_ev;

    /**
     * The value for the soli field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $soli;

    /**
     * The value for the rentenversicherung field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $rentenversicherung;

    /**
     * The value for the krankenversicherung field.
     * Note: this column has a database default value of: '0'
     * @var        string
     */
    protected $krankenversicherung;

    /**
     * The value for the ma_id field.
     * @var        int
     */
    protected $ma_id;

    /**
     * The value for the lp_id field.
     * @var        int
     */
    protected $lp_id;

    /**
     * The value for the class_key field.
     * @var        int
     */
    protected $class_key;

    /**
     * @var        Mitarbeiter
     */
    protected $aMitarbeiter;

    /**
     * @var        Lohnprofil
     */
    protected $aLohnprofil;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->arbeitsstunden = '0';
        $this->brutto = '0';
        $this->zulage = '0';
        $this->netto = '0';
        $this->lohnsteuer = '0';
        $this->kirchensteuer_rk = '0';
        $this->kirchensteuer_ev = '0';
        $this->soli = '0';
        $this->rentenversicherung = '0';
        $this->krankenversicherung = '0';
    }

    /**
     * Initializes internal state of BaseLohnabrechnung object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [monat] column value.
     *
     * @return string
     */
    public function getMonat()
    {

        return $this->monat;
    }

    /**
     * Get the [arbeitsstunden] column value.
     *
     * @return string
     */
    public function getArbeitsstunden()
    {

        return $this->arbeitsstunden;
    }

    /**
     * Get the [brutto] column value.
     *
     * @return string
     */
    public function getBrutto()
    {

        return $this->brutto;
    }

    /**
     * Get the [zulage] column value.
     *
     * @return string
     */
    public function getZulage()
    {

        return $this->zulage;
    }

    /**
     * Get the [netto] column value.
     *
     * @return string
     */
    public function getNetto()
    {

        return $this->netto;
    }

    /**
     * Get the [lohnsteuer] column value.
     *
     * @return string
     */
    public function getLohnsteuer()
    {

        return $this->lohnsteuer;
    }

    /**
     * Get the [kirchensteuer_rk] column value.
     *
     * @return string
     */
    public function getKirchensteuerRk()
    {

        return $this->kirchensteuer_rk;
    }

    /**
     * Get the [kirchensteuer_ev] column value.
     *
     * @return string
     */
    public function getKirchensteuerEv()
    {

        return $this->kirchensteuer_ev;
    }

    /**
     * Get the [soli] column value.
     *
     * @return string
     */
    public function getSoli()
    {

        return $this->soli;
    }

    /**
     * Get the [rentenversicherung] column value.
     *
     * @return string
     */
    public function getRentenversicherung()
    {

        return $this->rentenversicherung;
    }

    /**
     * Get the [krankenversicherung] column value.
     *
     * @return string
     */
    public function getKrankenversicherung()
    {

        return $this->krankenversicherung;
    }

    /**
     * Get the [ma_id] column value.
     *
     * @return int
     */
    public function getMaId()
    {

        return $this->ma_id;
    }

    /**
     * Get the [lp_id] column value.
     *
     * @return int
     */
    public function getLpId()
    {

        return $this->lp_id;
    }

    /**
     * Get the [class_key] column value.
     *
     * @return int
     */
    public function getClassKey()
    {

        return $this->class_key;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [monat] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setMonat($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->monat !== $v) {
            $this->monat = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::MONAT;
        }


        return $this;
    } // setMonat()

    /**
     * Set the value of [arbeitsstunden] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setArbeitsstunden($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->arbeitsstunden !== $v) {
            $this->arbeitsstunden = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::ARBEITSSTUNDEN;
        }


        return $this;
    } // setArbeitsstunden()

    /**
     * Set the value of [brutto] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setBrutto($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->brutto !== $v) {
            $this->brutto = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::BRUTTO;
        }


        return $this;
    } // setBrutto()

    /**
     * Set the value of [zulage] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setZulage($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->zulage !== $v) {
            $this->zulage = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::ZULAGE;
        }


        return $this;
    } // setZulage()

    /**
     * Set the value of [netto] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setNetto($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->netto !== $v) {
            $this->netto = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::NETTO;
        }


        return $this;
    } // setNetto()

    /**
     * Set the value of [lohnsteuer] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setLohnsteuer($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->lohnsteuer !== $v) {
            $this->lohnsteuer = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::LOHNSTEUER;
        }


        return $this;
    } // setLohnsteuer()

    /**
     * Set the value of [kirchensteuer_rk] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setKirchensteuerRk($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->kirchensteuer_rk !== $v) {
            $this->kirchensteuer_rk = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::KIRCHENSTEUER_RK;
        }


        return $this;
    } // setKirchensteuerRk()

    /**
     * Set the value of [kirchensteuer_ev] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setKirchensteuerEv($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->kirchensteuer_ev !== $v) {
            $this->kirchensteuer_ev = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::KIRCHENSTEUER_EV;
        }


        return $this;
    } // setKirchensteuerEv()

    /**
     * Set the value of [soli] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setSoli($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->soli !== $v) {
            $this->soli = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::SOLI;
        }


        return $this;
    } // setSoli()

    /**
     * Set the value of [rentenversicherung] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setRentenversicherung($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->rentenversicherung !== $v) {
            $this->rentenversicherung = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::RENTENVERSICHERUNG;
        }


        return $this;
    } // setRentenversicherung()

    /**
     * Set the value of [krankenversicherung] column.
     *
     * @param  string $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setKrankenversicherung($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (string) $v;
        }

        if ($this->krankenversicherung !== $v) {
            $this->krankenversicherung = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::KRANKENVERSICHERUNG;
        }


        return $this;
    } // setKrankenversicherung()

    /**
     * Set the value of [ma_id] column.
     *
     * @param  int $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setMaId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->ma_id !== $v) {
            $this->ma_id = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::MA_ID;
        }

        if ($this->aMitarbeiter !== null && $this->aMitarbeiter->getId() !== $v) {
            $this->aMitarbeiter = null;
        }


        return $this;
    } // setMaId()

    /**
     * Set the value of [lp_id] column.
     *
     * @param  int $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setLpId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->lp_id !== $v) {
            $this->lp_id = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::LP_ID;
        }

        if ($this->aLohnprofil !== null && $this->aLohnprofil->getId() !== $v) {
            $this->aLohnprofil = null;
        }


        return $this;
    } // setLpId()

    /**
     * Set the value of [class_key] column.
     *
     * @param  int $v new value
     * @return Lohnabrechnung The current object (for fluent API support)
     */
    public function setClassKey($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->class_key !== $v) {
            $this->class_key = $v;
            $this->modifiedColumns[] = LohnabrechnungPeer::CLASS_KEY;
        }


        return $this;
    } // setClassKey()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->arbeitsstunden !== '0') {
                return false;
            }

            if ($this->brutto !== '0') {
                return false;
            }

            if ($this->zulage !== '0') {
                return false;
            }

            if ($this->netto !== '0') {
                return false;
            }

            if ($this->lohnsteuer !== '0') {
                return false;
            }

            if ($this->kirchensteuer_rk !== '0') {
                return false;
            }

            if ($this->kirchensteuer_ev !== '0') {
                return false;
            }

            if ($this->soli !== '0') {
                return false;
            }

            if ($this->rentenversicherung !== '0') {
                return false;
            }

            if ($this->krankenversicherung !== '0') {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->monat = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->arbeitsstunden = ($row[$startcol + 3] !== null) ? (string) $row[$startcol + 3] : null;
            $this->brutto = ($row[$startcol + 4] !== null) ? (string) $row[$startcol + 4] : null;
            $this->zulage = ($row[$startcol + 5] !== null) ? (string) $row[$startcol + 5] : null;
            $this->netto = ($row[$startcol + 6] !== null) ? (string) $row[$startcol + 6] : null;
            $this->lohnsteuer = ($row[$startcol + 7] !== null) ? (string) $row[$startcol + 7] : null;
            $this->kirchensteuer_rk = ($row[$startcol + 8] !== null) ? (string) $row[$startcol + 8] : null;
            $this->kirchensteuer_ev = ($row[$startcol + 9] !== null) ? (string) $row[$startcol + 9] : null;
            $this->soli = ($row[$startcol + 10] !== null) ? (string) $row[$startcol + 10] : null;
            $this->rentenversicherung = ($row[$startcol + 11] !== null) ? (string) $row[$startcol + 11] : null;
            $this->krankenversicherung = ($row[$startcol + 12] !== null) ? (string) $row[$startcol + 12] : null;
            $this->ma_id = ($row[$startcol + 13] !== null) ? (int) $row[$startcol + 13] : null;
            $this->lp_id = ($row[$startcol + 14] !== null) ? (int) $row[$startcol + 14] : null;
            $this->class_key = ($row[$startcol + 15] !== null) ? (int) $row[$startcol + 15] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 16; // 16 = LohnabrechnungPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating Lohnabrechnung object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

        if ($this->aMitarbeiter !== null && $this->ma_id !== $this->aMitarbeiter->getId()) {
            $this->aMitarbeiter = null;
        }
        if ($this->aLohnprofil !== null && $this->lp_id !== $this->aLohnprofil->getId()) {
            $this->aLohnprofil = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = LohnabrechnungPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aMitarbeiter = null;
            $this->aLohnprofil = null;
        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = LohnabrechnungQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnabrechnungPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                LohnabrechnungPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aMitarbeiter !== null) {
                if ($this->aMitarbeiter->isModified() || $this->aMitarbeiter->isNew()) {
                    $affectedRows += $this->aMitarbeiter->save($con);
                }
                $this->setMitarbeiter($this->aMitarbeiter);
            }

            if ($this->aLohnprofil !== null) {
                if ($this->aLohnprofil->isModified() || $this->aLohnprofil->isNew()) {
                    $affectedRows += $this->aLohnprofil->save($con);
                }
                $this->setLohnprofil($this->aLohnprofil);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = LohnabrechnungPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . LohnabrechnungPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(LohnabrechnungPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::MONAT)) {
            $modifiedColumns[':p' . $index++]  = '`monat`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::ARBEITSSTUNDEN)) {
            $modifiedColumns[':p' . $index++]  = '`arbeitsstunden`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::BRUTTO)) {
            $modifiedColumns[':p' . $index++]  = '`brutto`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::ZULAGE)) {
            $modifiedColumns[':p' . $index++]  = '`zulage`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::NETTO)) {
            $modifiedColumns[':p' . $index++]  = '`netto`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::LOHNSTEUER)) {
            $modifiedColumns[':p' . $index++]  = '`lohnsteuer`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::KIRCHENSTEUER_RK)) {
            $modifiedColumns[':p' . $index++]  = '`kirchensteuer_rk`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::KIRCHENSTEUER_EV)) {
            $modifiedColumns[':p' . $index++]  = '`kirchensteuer_ev`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::SOLI)) {
            $modifiedColumns[':p' . $index++]  = '`soli`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::RENTENVERSICHERUNG)) {
            $modifiedColumns[':p' . $index++]  = '`rentenversicherung`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::KRANKENVERSICHERUNG)) {
            $modifiedColumns[':p' . $index++]  = '`krankenversicherung`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::MA_ID)) {
            $modifiedColumns[':p' . $index++]  = '`ma_id`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::LP_ID)) {
            $modifiedColumns[':p' . $index++]  = '`lp_id`';
        }
        if ($this->isColumnModified(LohnabrechnungPeer::CLASS_KEY)) {
            $modifiedColumns[':p' . $index++]  = '`class_key`';
        }

        $sql = sprintf(
            'INSERT INTO `lohnabrechnung` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`monat`':
                        $stmt->bindValue($identifier, $this->monat, PDO::PARAM_STR);
                        break;
                    case '`arbeitsstunden`':
                        $stmt->bindValue($identifier, $this->arbeitsstunden, PDO::PARAM_INT);
                        break;
                    case '`brutto`':
                        $stmt->bindValue($identifier, $this->brutto, PDO::PARAM_INT);
                        break;
                    case '`zulage`':
                        $stmt->bindValue($identifier, $this->zulage, PDO::PARAM_INT);
                        break;
                    case '`netto`':
                        $stmt->bindValue($identifier, $this->netto, PDO::PARAM_INT);
                        break;
                    case '`lohnsteuer`':
                        $stmt->bindValue($identifier, $this->lohnsteuer, PDO::PARAM_INT);
                        break;
                    case '`kirchensteuer_rk`':
                        $stmt->bindValue($identifier, $this->kirchensteuer_rk, PDO::PARAM_STR);
                        break;
                    case '`kirchensteuer_ev`':
                        $stmt->bindValue($identifier, $this->kirchensteuer_ev, PDO::PARAM_INT);
                        break;
                    case '`soli`':
                        $stmt->bindValue($identifier, $this->soli, PDO::PARAM_INT);
                        break;
                    case '`rentenversicherung`':
                        $stmt->bindValue($identifier, $this->rentenversicherung, PDO::PARAM_INT);
                        break;
                    case '`krankenversicherung`':
                        $stmt->bindValue($identifier, $this->krankenversicherung, PDO::PARAM_INT);
                        break;
                    case '`ma_id`':
                        $stmt->bindValue($identifier, $this->ma_id, PDO::PARAM_INT);
                        break;
                    case '`lp_id`':
                        $stmt->bindValue($identifier, $this->lp_id, PDO::PARAM_INT);
                        break;
                    case '`class_key`':
                        $stmt->bindValue($identifier, $this->class_key, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            // We call the validate method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aMitarbeiter !== null) {
                if (!$this->aMitarbeiter->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aMitarbeiter->getValidationFailures());
                }
            }

            if ($this->aLohnprofil !== null) {
                if (!$this->aLohnprofil->validate($columns)) {
                    $failureMap = array_merge($failureMap, $this->aLohnprofil->getValidationFailures());
                }
            }


            if (($retval = LohnabrechnungPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }



            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = LohnabrechnungPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getMonat();
                break;
            case 3:
                return $this->getArbeitsstunden();
                break;
            case 4:
                return $this->getBrutto();
                break;
            case 5:
                return $this->getZulage();
                break;
            case 6:
                return $this->getNetto();
                break;
            case 7:
                return $this->getLohnsteuer();
                break;
            case 8:
                return $this->getKirchensteuerRk();
                break;
            case 9:
                return $this->getKirchensteuerEv();
                break;
            case 10:
                return $this->getSoli();
                break;
            case 11:
                return $this->getRentenversicherung();
                break;
            case 12:
                return $this->getKrankenversicherung();
                break;
            case 13:
                return $this->getMaId();
                break;
            case 14:
                return $this->getLpId();
                break;
            case 15:
                return $this->getClassKey();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['Lohnabrechnung'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['Lohnabrechnung'][$this->getPrimaryKey()] = true;
        $keys = LohnabrechnungPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getMonat(),
            $keys[3] => $this->getArbeitsstunden(),
            $keys[4] => $this->getBrutto(),
            $keys[5] => $this->getZulage(),
            $keys[6] => $this->getNetto(),
            $keys[7] => $this->getLohnsteuer(),
            $keys[8] => $this->getKirchensteuerRk(),
            $keys[9] => $this->getKirchensteuerEv(),
            $keys[10] => $this->getSoli(),
            $keys[11] => $this->getRentenversicherung(),
            $keys[12] => $this->getKrankenversicherung(),
            $keys[13] => $this->getMaId(),
            $keys[14] => $this->getLpId(),
            $keys[15] => $this->getClassKey(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aMitarbeiter) {
                $result['Mitarbeiter'] = $this->aMitarbeiter->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->aLohnprofil) {
                $result['Lohnprofil'] = $this->aLohnprofil->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = LohnabrechnungPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setMonat($value);
                break;
            case 3:
                $this->setArbeitsstunden($value);
                break;
            case 4:
                $this->setBrutto($value);
                break;
            case 5:
                $this->setZulage($value);
                break;
            case 6:
                $this->setNetto($value);
                break;
            case 7:
                $this->setLohnsteuer($value);
                break;
            case 8:
                $this->setKirchensteuerRk($value);
                break;
            case 9:
                $this->setKirchensteuerEv($value);
                break;
            case 10:
                $this->setSoli($value);
                break;
            case 11:
                $this->setRentenversicherung($value);
                break;
            case 12:
                $this->setKrankenversicherung($value);
                break;
            case 13:
                $this->setMaId($value);
                break;
            case 14:
                $this->setLpId($value);
                break;
            case 15:
                $this->setClassKey($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = LohnabrechnungPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setMonat($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setArbeitsstunden($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setBrutto($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setZulage($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setNetto($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setLohnsteuer($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setKirchensteuerRk($arr[$keys[8]]);
        if (array_key_exists($keys[9], $arr)) $this->setKirchensteuerEv($arr[$keys[9]]);
        if (array_key_exists($keys[10], $arr)) $this->setSoli($arr[$keys[10]]);
        if (array_key_exists($keys[11], $arr)) $this->setRentenversicherung($arr[$keys[11]]);
        if (array_key_exists($keys[12], $arr)) $this->setKrankenversicherung($arr[$keys[12]]);
        if (array_key_exists($keys[13], $arr)) $this->setMaId($arr[$keys[13]]);
        if (array_key_exists($keys[14], $arr)) $this->setLpId($arr[$keys[14]]);
        if (array_key_exists($keys[15], $arr)) $this->setClassKey($arr[$keys[15]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);

        if ($this->isColumnModified(LohnabrechnungPeer::ID)) $criteria->add(LohnabrechnungPeer::ID, $this->id);
        if ($this->isColumnModified(LohnabrechnungPeer::MOD)) $criteria->add(LohnabrechnungPeer::MOD, $this->mod);
        if ($this->isColumnModified(LohnabrechnungPeer::MONAT)) $criteria->add(LohnabrechnungPeer::MONAT, $this->monat);
        if ($this->isColumnModified(LohnabrechnungPeer::ARBEITSSTUNDEN)) $criteria->add(LohnabrechnungPeer::ARBEITSSTUNDEN, $this->arbeitsstunden);
        if ($this->isColumnModified(LohnabrechnungPeer::BRUTTO)) $criteria->add(LohnabrechnungPeer::BRUTTO, $this->brutto);
        if ($this->isColumnModified(LohnabrechnungPeer::ZULAGE)) $criteria->add(LohnabrechnungPeer::ZULAGE, $this->zulage);
        if ($this->isColumnModified(LohnabrechnungPeer::NETTO)) $criteria->add(LohnabrechnungPeer::NETTO, $this->netto);
        if ($this->isColumnModified(LohnabrechnungPeer::LOHNSTEUER)) $criteria->add(LohnabrechnungPeer::LOHNSTEUER, $this->lohnsteuer);
        if ($this->isColumnModified(LohnabrechnungPeer::KIRCHENSTEUER_RK)) $criteria->add(LohnabrechnungPeer::KIRCHENSTEUER_RK, $this->kirchensteuer_rk);
        if ($this->isColumnModified(LohnabrechnungPeer::KIRCHENSTEUER_EV)) $criteria->add(LohnabrechnungPeer::KIRCHENSTEUER_EV, $this->kirchensteuer_ev);
        if ($this->isColumnModified(LohnabrechnungPeer::SOLI)) $criteria->add(LohnabrechnungPeer::SOLI, $this->soli);
        if ($this->isColumnModified(LohnabrechnungPeer::RENTENVERSICHERUNG)) $criteria->add(LohnabrechnungPeer::RENTENVERSICHERUNG, $this->rentenversicherung);
        if ($this->isColumnModified(LohnabrechnungPeer::KRANKENVERSICHERUNG)) $criteria->add(LohnabrechnungPeer::KRANKENVERSICHERUNG, $this->krankenversicherung);
        if ($this->isColumnModified(LohnabrechnungPeer::MA_ID)) $criteria->add(LohnabrechnungPeer::MA_ID, $this->ma_id);
        if ($this->isColumnModified(LohnabrechnungPeer::LP_ID)) $criteria->add(LohnabrechnungPeer::LP_ID, $this->lp_id);
        if ($this->isColumnModified(LohnabrechnungPeer::CLASS_KEY)) $criteria->add(LohnabrechnungPeer::CLASS_KEY, $this->class_key);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(LohnabrechnungPeer::DATABASE_NAME);
        $criteria->add(LohnabrechnungPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of Lohnabrechnung (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setMonat($this->getMonat());
        $copyObj->setArbeitsstunden($this->getArbeitsstunden());
        $copyObj->setBrutto($this->getBrutto());
        $copyObj->setZulage($this->getZulage());
        $copyObj->setNetto($this->getNetto());
        $copyObj->setLohnsteuer($this->getLohnsteuer());
        $copyObj->setKirchensteuerRk($this->getKirchensteuerRk());
        $copyObj->setKirchensteuerEv($this->getKirchensteuerEv());
        $copyObj->setSoli($this->getSoli());
        $copyObj->setRentenversicherung($this->getRentenversicherung());
        $copyObj->setKrankenversicherung($this->getKrankenversicherung());
        $copyObj->setMaId($this->getMaId());
        $copyObj->setLpId($this->getLpId());
        $copyObj->setClassKey($this->getClassKey());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return Lohnabrechnung Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return LohnabrechnungPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new LohnabrechnungPeer();
        }

        return self::$peer;
    }

    /**
     * Declares an association between this object and a Mitarbeiter object.
     *
     * @param                  Mitarbeiter $v
     * @return Lohnabrechnung The current object (for fluent API support)
     * @throws PropelException
     */
    public function setMitarbeiter(Mitarbeiter $v = null)
    {
        if ($v === null) {
            $this->setMaId(NULL);
        } else {
            $this->setMaId($v->getId());
        }

        $this->aMitarbeiter = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the Mitarbeiter object, it will not be re-added.
        if ($v !== null) {
            $v->addLA($this);
        }


        return $this;
    }


    /**
     * Get the associated Mitarbeiter object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return Mitarbeiter The associated Mitarbeiter object.
     * @throws PropelException
     */
    public function getMitarbeiter(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aMitarbeiter === null && ($this->ma_id !== null) && $doQuery) {
            $this->aMitarbeiter = MitarbeiterQuery::create()->findPk($this->ma_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aMitarbeiter->addLAs($this);
             */
        }

        return $this->aMitarbeiter;
    }

    /**
     * Declares an association between this object and a Lohnprofil object.
     *
     * @param                  Lohnprofil $v
     * @return Lohnabrechnung The current object (for fluent API support)
     * @throws PropelException
     */
    public function setLohnprofil(Lohnprofil $v = null)
    {
        if ($v === null) {
            $this->setLpId(NULL);
        } else {
            $this->setLpId($v->getId());
        }

        $this->aLohnprofil = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the Lohnprofil object, it will not be re-added.
        if ($v !== null) {
            $v->addLA($this);
        }


        return $this;
    }


    /**
     * Get the associated Lohnprofil object
     *
     * @param PropelPDO $con Optional Connection object.
     * @param $doQuery Executes a query to get the object if required
     * @return Lohnprofil The associated Lohnprofil object.
     * @throws PropelException
     */
    public function getLohnprofil(PropelPDO $con = null, $doQuery = true)
    {
        if ($this->aLohnprofil === null && ($this->lp_id !== null) && $doQuery) {
            $this->aLohnprofil = LohnprofilQuery::create()->findPk($this->lp_id, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aLohnprofil->addLAs($this);
             */
        }

        return $this->aLohnprofil;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->monat = null;
        $this->arbeitsstunden = null;
        $this->brutto = null;
        $this->zulage = null;
        $this->netto = null;
        $this->lohnsteuer = null;
        $this->kirchensteuer_rk = null;
        $this->kirchensteuer_ev = null;
        $this->soli = null;
        $this->rentenversicherung = null;
        $this->krankenversicherung = null;
        $this->ma_id = null;
        $this->lp_id = null;
        $this->class_key = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->aMitarbeiter instanceof Persistent) {
              $this->aMitarbeiter->clearAllReferences($deep);
            }
            if ($this->aLohnprofil instanceof Persistent) {
              $this->aLohnprofil->clearAllReferences($deep);
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        $this->aMitarbeiter = null;
        $this->aLohnprofil = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(LohnabrechnungPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
