<?php


/**
 * Base class that represents a row from the 'lohnprofil' table.
 *
 *
 *
 * @package    propel.generator.propel.om
 */
abstract class BaseLohnprofil extends BaseObject implements Persistent
{
    /**
     * Peer class name
     */
    const PEER = 'LohnprofilPeer';

    /**
     * The Peer class.
     * Instance provides a convenient way of calling static methods on a class
     * that calling code may not be able to identify.
     * @var        LohnprofilPeer
     */
    protected static $peer;

    /**
     * The flag var to prevent infinite loop in deep copy
     * @var       boolean
     */
    protected $startCopy = false;

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the mod field.
     * @var        int
     */
    protected $mod;

    /**
     * The value for the name field.
     * @var        string
     */
    protected $name;

    /**
     * The value for the periode field.
     * @var        int
     */
    protected $periode;

    /**
     * The value for the lohnsteuer field.
     * Note: this column has a database default value of: false
     * @var        boolean
     */
    protected $lohnsteuer;

    /**
     * The value for the kirchensteuer_rk field.
     * Note: this column has a database default value of: false
     * @var        boolean
     */
    protected $kirchensteuer_rk;

    /**
     * The value for the kirchensteuer_ev field.
     * Note: this column has a database default value of: false
     * @var        boolean
     */
    protected $kirchensteuer_ev;

    /**
     * The value for the soli field.
     * Note: this column has a database default value of: false
     * @var        boolean
     */
    protected $soli;

    /**
     * The value for the rentenversicherung_an field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $rentenversicherung_an;

    /**
     * The value for the rentenversicherung_ag field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $rentenversicherung_ag;

    /**
     * The value for the krankenversicherung_an field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $krankenversicherung_an;

    /**
     * The value for the krankenversicherung_ag field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $krankenversicherung_ag;

    /**
     * The value for the u1 field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $u1;

    /**
     * The value for the u2 field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $u2;

    /**
     * The value for the inso field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $inso;

    /**
     * The value for the pauschalsteuer field.
     * Note: this column has a database default value of: 0.0
     * @var        double
     */
    protected $pauschalsteuer;

    /**
     * The value for the la_typ field.
     * @var        int
     */
    protected $la_typ;

    /**
     * @var        PropelObjectCollection|Lohnabrechnung[] Collection to store aggregation of Lohnabrechnung objects.
     */
    protected $collLAs;
    protected $collLAsPartial;

    /**
     * @var        PropelObjectCollection|Mitarbeiter[] Collection to store aggregation of Mitarbeiter objects.
     */
    protected $collMAs;
    protected $collMAsPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInSave = false;

    /**
     * Flag to prevent endless validation loop, if this object is referenced
     * by another object which falls in this transaction.
     * @var        boolean
     */
    protected $alreadyInValidation = false;

    /**
     * Flag to prevent endless clearAllReferences($deep=true) loop, if this object is referenced
     * @var        boolean
     */
    protected $alreadyInClearAllReferencesDeep = false;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $lAsScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var		PropelObjectCollection
     */
    protected $mAsScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see        __construct()
     */
    public function applyDefaultValues()
    {
        $this->lohnsteuer = false;
        $this->kirchensteuer_rk = false;
        $this->kirchensteuer_ev = false;
        $this->soli = false;
        $this->rentenversicherung_an = 0.0;
        $this->rentenversicherung_ag = 0.0;
        $this->krankenversicherung_an = 0.0;
        $this->krankenversicherung_ag = 0.0;
        $this->u1 = 0.0;
        $this->u2 = 0.0;
        $this->inso = 0.0;
        $this->pauschalsteuer = 0.0;
    }

    /**
     * Initializes internal state of BaseLohnprofil object.
     * @see        applyDefaults()
     */
    public function __construct()
    {
        parent::__construct();
        $this->applyDefaultValues();
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {

        return $this->id;
    }

    /**
     * Get the [mod] column value.
     *
     * @return int
     */
    public function getMod()
    {

        return $this->mod;
    }

    /**
     * Get the [name] column value.
     *
     * @return string
     */
    public function getName()
    {

        return $this->name;
    }

    /**
     * Get the [periode] column value.
     *
     * @return int
     */
    public function getPeriode()
    {

        return $this->periode;
    }

    /**
     * Get the [lohnsteuer] column value.
     *
     * @return boolean
     */
    public function getLohnsteuer()
    {

        return $this->lohnsteuer;
    }

    /**
     * Get the [kirchensteuer_rk] column value.
     *
     * @return boolean
     */
    public function getKirchensteuerRk()
    {

        return $this->kirchensteuer_rk;
    }

    /**
     * Get the [kirchensteuer_ev] column value.
     *
     * @return boolean
     */
    public function getKirchensteuerEv()
    {

        return $this->kirchensteuer_ev;
    }

    /**
     * Get the [soli] column value.
     *
     * @return boolean
     */
    public function getSoli()
    {

        return $this->soli;
    }

    /**
     * Get the [rentenversicherung_an] column value.
     *
     * @return double
     */
    public function getRentenversicherungAn()
    {

        return $this->rentenversicherung_an;
    }

    /**
     * Get the [rentenversicherung_ag] column value.
     *
     * @return double
     */
    public function getRentenversicherungAg()
    {

        return $this->rentenversicherung_ag;
    }

    /**
     * Get the [krankenversicherung_an] column value.
     *
     * @return double
     */
    public function getKrankenversicherungAn()
    {

        return $this->krankenversicherung_an;
    }

    /**
     * Get the [krankenversicherung_ag] column value.
     *
     * @return double
     */
    public function getKrankenversicherungAg()
    {

        return $this->krankenversicherung_ag;
    }

    /**
     * Get the [u1] column value.
     *
     * @return double
     */
    public function getU1()
    {

        return $this->u1;
    }

    /**
     * Get the [u2] column value.
     *
     * @return double
     */
    public function getU2()
    {

        return $this->u2;
    }

    /**
     * Get the [inso] column value.
     *
     * @return double
     */
    public function getInso()
    {

        return $this->inso;
    }

    /**
     * Get the [pauschalsteuer] column value.
     *
     * @return double
     */
    public function getPauschalsteuer()
    {

        return $this->pauschalsteuer;
    }

    /**
     * Get the [la_typ] column value.
     *
     * @return int
     */
    public function getLaTyp()
    {

        return $this->la_typ;
    }

    /**
     * Set the value of [id] column.
     *
     * @param  int $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[] = LohnprofilPeer::ID;
        }


        return $this;
    } // setId()

    /**
     * Set the value of [mod] column.
     *
     * @param  int $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setMod($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->mod !== $v) {
            $this->mod = $v;
            $this->modifiedColumns[] = LohnprofilPeer::MOD;
        }


        return $this;
    } // setMod()

    /**
     * Set the value of [name] column.
     *
     * @param  string $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setName($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->name !== $v) {
            $this->name = $v;
            $this->modifiedColumns[] = LohnprofilPeer::NAME;
        }


        return $this;
    } // setName()

    /**
     * Set the value of [periode] column.
     *
     * @param  int $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setPeriode($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->periode !== $v) {
            $this->periode = $v;
            $this->modifiedColumns[] = LohnprofilPeer::PERIODE;
        }


        return $this;
    } // setPeriode()

    /**
     * Sets the value of the [lohnsteuer] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setLohnsteuer($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->lohnsteuer !== $v) {
            $this->lohnsteuer = $v;
            $this->modifiedColumns[] = LohnprofilPeer::LOHNSTEUER;
        }


        return $this;
    } // setLohnsteuer()

    /**
     * Sets the value of the [kirchensteuer_rk] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setKirchensteuerRk($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->kirchensteuer_rk !== $v) {
            $this->kirchensteuer_rk = $v;
            $this->modifiedColumns[] = LohnprofilPeer::KIRCHENSTEUER_RK;
        }


        return $this;
    } // setKirchensteuerRk()

    /**
     * Sets the value of the [kirchensteuer_ev] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setKirchensteuerEv($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->kirchensteuer_ev !== $v) {
            $this->kirchensteuer_ev = $v;
            $this->modifiedColumns[] = LohnprofilPeer::KIRCHENSTEUER_EV;
        }


        return $this;
    } // setKirchensteuerEv()

    /**
     * Sets the value of the [soli] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param boolean|integer|string $v The new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setSoli($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->soli !== $v) {
            $this->soli = $v;
            $this->modifiedColumns[] = LohnprofilPeer::SOLI;
        }


        return $this;
    } // setSoli()

    /**
     * Set the value of [rentenversicherung_an] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setRentenversicherungAn($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->rentenversicherung_an !== $v) {
            $this->rentenversicherung_an = $v;
            $this->modifiedColumns[] = LohnprofilPeer::RENTENVERSICHERUNG_AN;
        }


        return $this;
    } // setRentenversicherungAn()

    /**
     * Set the value of [rentenversicherung_ag] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setRentenversicherungAg($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->rentenversicherung_ag !== $v) {
            $this->rentenversicherung_ag = $v;
            $this->modifiedColumns[] = LohnprofilPeer::RENTENVERSICHERUNG_AG;
        }


        return $this;
    } // setRentenversicherungAg()

    /**
     * Set the value of [krankenversicherung_an] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setKrankenversicherungAn($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->krankenversicherung_an !== $v) {
            $this->krankenversicherung_an = $v;
            $this->modifiedColumns[] = LohnprofilPeer::KRANKENVERSICHERUNG_AN;
        }


        return $this;
    } // setKrankenversicherungAn()

    /**
     * Set the value of [krankenversicherung_ag] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setKrankenversicherungAg($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->krankenversicherung_ag !== $v) {
            $this->krankenversicherung_ag = $v;
            $this->modifiedColumns[] = LohnprofilPeer::KRANKENVERSICHERUNG_AG;
        }


        return $this;
    } // setKrankenversicherungAg()

    /**
     * Set the value of [u1] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setU1($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->u1 !== $v) {
            $this->u1 = $v;
            $this->modifiedColumns[] = LohnprofilPeer::U1;
        }


        return $this;
    } // setU1()

    /**
     * Set the value of [u2] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setU2($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->u2 !== $v) {
            $this->u2 = $v;
            $this->modifiedColumns[] = LohnprofilPeer::U2;
        }


        return $this;
    } // setU2()

    /**
     * Set the value of [inso] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setInso($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->inso !== $v) {
            $this->inso = $v;
            $this->modifiedColumns[] = LohnprofilPeer::INSO;
        }


        return $this;
    } // setInso()

    /**
     * Set the value of [pauschalsteuer] column.
     *
     * @param  double $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setPauschalsteuer($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (double) $v;
        }

        if ($this->pauschalsteuer !== $v) {
            $this->pauschalsteuer = $v;
            $this->modifiedColumns[] = LohnprofilPeer::PAUSCHALSTEUER;
        }


        return $this;
    } // setPauschalsteuer()

    /**
     * Set the value of [la_typ] column.
     *
     * @param  int $v new value
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setLaTyp($v)
    {
        if ($v !== null && is_numeric($v)) {
            $v = (int) $v;
        }

        if ($this->la_typ !== $v) {
            $this->la_typ = $v;
            $this->modifiedColumns[] = LohnprofilPeer::LA_TYP;
        }


        return $this;
    } // setLaTyp()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->lohnsteuer !== false) {
                return false;
            }

            if ($this->kirchensteuer_rk !== false) {
                return false;
            }

            if ($this->kirchensteuer_ev !== false) {
                return false;
            }

            if ($this->soli !== false) {
                return false;
            }

            if ($this->rentenversicherung_an !== 0.0) {
                return false;
            }

            if ($this->rentenversicherung_ag !== 0.0) {
                return false;
            }

            if ($this->krankenversicherung_an !== 0.0) {
                return false;
            }

            if ($this->krankenversicherung_ag !== 0.0) {
                return false;
            }

            if ($this->u1 !== 0.0) {
                return false;
            }

            if ($this->u2 !== 0.0) {
                return false;
            }

            if ($this->inso !== 0.0) {
                return false;
            }

            if ($this->pauschalsteuer !== 0.0) {
                return false;
            }

        // otherwise, everything was equal, so return true
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array $row The row returned by PDOStatement->fetch(PDO::FETCH_NUM)
     * @param int $startcol 0-based offset column which indicates which resultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false)
    {
        try {

            $this->id = ($row[$startcol + 0] !== null) ? (int) $row[$startcol + 0] : null;
            $this->mod = ($row[$startcol + 1] !== null) ? (int) $row[$startcol + 1] : null;
            $this->name = ($row[$startcol + 2] !== null) ? (string) $row[$startcol + 2] : null;
            $this->periode = ($row[$startcol + 3] !== null) ? (int) $row[$startcol + 3] : null;
            $this->lohnsteuer = ($row[$startcol + 4] !== null) ? (boolean) $row[$startcol + 4] : null;
            $this->kirchensteuer_rk = ($row[$startcol + 5] !== null) ? (boolean) $row[$startcol + 5] : null;
            $this->kirchensteuer_ev = ($row[$startcol + 6] !== null) ? (boolean) $row[$startcol + 6] : null;
            $this->soli = ($row[$startcol + 7] !== null) ? (boolean) $row[$startcol + 7] : null;
            $this->rentenversicherung_an = ($row[$startcol + 8] !== null) ? (double) $row[$startcol + 8] : null;
            $this->rentenversicherung_ag = ($row[$startcol + 9] !== null) ? (double) $row[$startcol + 9] : null;
            $this->krankenversicherung_an = ($row[$startcol + 10] !== null) ? (double) $row[$startcol + 10] : null;
            $this->krankenversicherung_ag = ($row[$startcol + 11] !== null) ? (double) $row[$startcol + 11] : null;
            $this->u1 = ($row[$startcol + 12] !== null) ? (double) $row[$startcol + 12] : null;
            $this->u2 = ($row[$startcol + 13] !== null) ? (double) $row[$startcol + 13] : null;
            $this->inso = ($row[$startcol + 14] !== null) ? (double) $row[$startcol + 14] : null;
            $this->pauschalsteuer = ($row[$startcol + 15] !== null) ? (double) $row[$startcol + 15] : null;
            $this->la_typ = ($row[$startcol + 16] !== null) ? (int) $row[$startcol + 16] : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }
            $this->postHydrate($row, $startcol, $rehydrate);

            return $startcol + 17; // 17 = LohnprofilPeer::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException("Error populating Lohnprofil object", $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {

    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param boolean $deep (optional) Whether to also de-associated any related objects.
     * @param PropelPDO $con (optional) The PropelPDO connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $stmt = LohnprofilPeer::doSelectStmt($this->buildPkeyCriteria(), $con);
        $row = $stmt->fetch(PDO::FETCH_NUM);
        $stmt->closeCursor();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->collLAs = null;

            $this->collMAs = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param PropelPDO $con
     * @return void
     * @throws PropelException
     * @throws Exception
     * @see        BaseObject::setDeleted()
     * @see        BaseObject::isDeleted()
     */
    public function delete(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        try {
            $deleteQuery = LohnprofilQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $con->commit();
                $this->setDeleted(true);
            } else {
                $con->commit();
            }
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @throws Exception
     * @see        doSave()
     */
    public function save(PropelPDO $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $con->beginTransaction();
        $isInsert = $this->isNew();
        try {
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                LohnprofilPeer::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param PropelPDO $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see        save()
     */
    protected function doSave(PropelPDO $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                } else {
                    $this->doUpdate($con);
                }
                $affectedRows += 1;
                $this->resetModified();
            }

            if ($this->lAsScheduledForDeletion !== null) {
                if (!$this->lAsScheduledForDeletion->isEmpty()) {
                    LohnabrechnungQuery::create()
                        ->filterByPrimaryKeys($this->lAsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->lAsScheduledForDeletion = null;
                }
            }

            if ($this->collLAs !== null) {
                foreach ($this->collLAs as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->mAsScheduledForDeletion !== null) {
                if (!$this->mAsScheduledForDeletion->isEmpty()) {
                    MitarbeiterQuery::create()
                        ->filterByPrimaryKeys($this->mAsScheduledForDeletion->getPrimaryKeys(false))
                        ->delete($con);
                    $this->mAsScheduledForDeletion = null;
                }
            }

            if ($this->collMAs !== null) {
                foreach ($this->collMAs as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param PropelPDO $con
     *
     * @throws PropelException
     * @see        doSave()
     */
    protected function doInsert(PropelPDO $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[] = LohnprofilPeer::ID;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . LohnprofilPeer::ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(LohnprofilPeer::ID)) {
            $modifiedColumns[':p' . $index++]  = '`id`';
        }
        if ($this->isColumnModified(LohnprofilPeer::MOD)) {
            $modifiedColumns[':p' . $index++]  = '`mod`';
        }
        if ($this->isColumnModified(LohnprofilPeer::NAME)) {
            $modifiedColumns[':p' . $index++]  = '`name`';
        }
        if ($this->isColumnModified(LohnprofilPeer::PERIODE)) {
            $modifiedColumns[':p' . $index++]  = '`periode`';
        }
        if ($this->isColumnModified(LohnprofilPeer::LOHNSTEUER)) {
            $modifiedColumns[':p' . $index++]  = '`lohnsteuer`';
        }
        if ($this->isColumnModified(LohnprofilPeer::KIRCHENSTEUER_RK)) {
            $modifiedColumns[':p' . $index++]  = '`kirchensteuer_rk`';
        }
        if ($this->isColumnModified(LohnprofilPeer::KIRCHENSTEUER_EV)) {
            $modifiedColumns[':p' . $index++]  = '`kirchensteuer_ev`';
        }
        if ($this->isColumnModified(LohnprofilPeer::SOLI)) {
            $modifiedColumns[':p' . $index++]  = '`soli`';
        }
        if ($this->isColumnModified(LohnprofilPeer::RENTENVERSICHERUNG_AN)) {
            $modifiedColumns[':p' . $index++]  = '`rentenversicherung_an`';
        }
        if ($this->isColumnModified(LohnprofilPeer::RENTENVERSICHERUNG_AG)) {
            $modifiedColumns[':p' . $index++]  = '`rentenversicherung_ag`';
        }
        if ($this->isColumnModified(LohnprofilPeer::KRANKENVERSICHERUNG_AN)) {
            $modifiedColumns[':p' . $index++]  = '`krankenversicherung_an`';
        }
        if ($this->isColumnModified(LohnprofilPeer::KRANKENVERSICHERUNG_AG)) {
            $modifiedColumns[':p' . $index++]  = '`krankenversicherung_ag`';
        }
        if ($this->isColumnModified(LohnprofilPeer::U1)) {
            $modifiedColumns[':p' . $index++]  = '`u1`';
        }
        if ($this->isColumnModified(LohnprofilPeer::U2)) {
            $modifiedColumns[':p' . $index++]  = '`u2`';
        }
        if ($this->isColumnModified(LohnprofilPeer::INSO)) {
            $modifiedColumns[':p' . $index++]  = '`inso`';
        }
        if ($this->isColumnModified(LohnprofilPeer::PAUSCHALSTEUER)) {
            $modifiedColumns[':p' . $index++]  = '`pauschalsteuer`';
        }
        if ($this->isColumnModified(LohnprofilPeer::LA_TYP)) {
            $modifiedColumns[':p' . $index++]  = '`la_typ`';
        }

        $sql = sprintf(
            'INSERT INTO `lohnprofil` (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case '`id`':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case '`mod`':
                        $stmt->bindValue($identifier, $this->mod, PDO::PARAM_INT);
                        break;
                    case '`name`':
                        $stmt->bindValue($identifier, $this->name, PDO::PARAM_STR);
                        break;
                    case '`periode`':
                        $stmt->bindValue($identifier, $this->periode, PDO::PARAM_INT);
                        break;
                    case '`lohnsteuer`':
                        $stmt->bindValue($identifier, (int) $this->lohnsteuer, PDO::PARAM_INT);
                        break;
                    case '`kirchensteuer_rk`':
                        $stmt->bindValue($identifier, (int) $this->kirchensteuer_rk, PDO::PARAM_INT);
                        break;
                    case '`kirchensteuer_ev`':
                        $stmt->bindValue($identifier, (int) $this->kirchensteuer_ev, PDO::PARAM_INT);
                        break;
                    case '`soli`':
                        $stmt->bindValue($identifier, (int) $this->soli, PDO::PARAM_INT);
                        break;
                    case '`rentenversicherung_an`':
                        $stmt->bindValue($identifier, $this->rentenversicherung_an, PDO::PARAM_STR);
                        break;
                    case '`rentenversicherung_ag`':
                        $stmt->bindValue($identifier, $this->rentenversicherung_ag, PDO::PARAM_STR);
                        break;
                    case '`krankenversicherung_an`':
                        $stmt->bindValue($identifier, $this->krankenversicherung_an, PDO::PARAM_STR);
                        break;
                    case '`krankenversicherung_ag`':
                        $stmt->bindValue($identifier, $this->krankenversicherung_ag, PDO::PARAM_STR);
                        break;
                    case '`u1`':
                        $stmt->bindValue($identifier, $this->u1, PDO::PARAM_STR);
                        break;
                    case '`u2`':
                        $stmt->bindValue($identifier, $this->u2, PDO::PARAM_STR);
                        break;
                    case '`inso`':
                        $stmt->bindValue($identifier, $this->inso, PDO::PARAM_STR);
                        break;
                    case '`pauschalsteuer`':
                        $stmt->bindValue($identifier, $this->pauschalsteuer, PDO::PARAM_STR);
                        break;
                    case '`la_typ`':
                        $stmt->bindValue($identifier, $this->la_typ, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param PropelPDO $con
     *
     * @see        doSave()
     */
    protected function doUpdate(PropelPDO $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();
        BasePeer::doUpdate($selectCriteria, $valuesCriteria, $con);
    }

    /**
     * Array of ValidationFailed objects.
     * @var        array ValidationFailed[]
     */
    protected $validationFailures = array();

    /**
     * Gets any ValidationFailed objects that resulted from last call to validate().
     *
     *
     * @return array ValidationFailed[]
     * @see        validate()
     */
    public function getValidationFailures()
    {
        return $this->validationFailures;
    }

    /**
     * Validates the objects modified field values and all objects related to this table.
     *
     * If $columns is either a column name or an array of column names
     * only those columns are validated.
     *
     * @param mixed $columns Column name or an array of column names.
     * @return boolean Whether all columns pass validation.
     * @see        doValidate()
     * @see        getValidationFailures()
     */
    public function validate($columns = null)
    {
        $res = $this->doValidate($columns);
        if ($res === true) {
            $this->validationFailures = array();

            return true;
        }

        $this->validationFailures = $res;

        return false;
    }

    /**
     * This function performs the validation work for complex object models.
     *
     * In addition to checking the current object, all related objects will
     * also be validated.  If all pass then <code>true</code> is returned; otherwise
     * an aggregated array of ValidationFailed objects will be returned.
     *
     * @param array $columns Array of column names to validate.
     * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objects otherwise.
     */
    protected function doValidate($columns = null)
    {
        if (!$this->alreadyInValidation) {
            $this->alreadyInValidation = true;
            $retval = null;

            $failureMap = array();


            if (($retval = LohnprofilPeer::doValidate($this, $columns)) !== true) {
                $failureMap = array_merge($failureMap, $retval);
            }


                if ($this->collLAs !== null) {
                    foreach ($this->collLAs as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }

                if ($this->collMAs !== null) {
                    foreach ($this->collMAs as $referrerFK) {
                        if (!$referrerFK->validate($columns)) {
                            $failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
                        }
                    }
                }


            $this->alreadyInValidation = false;
        }

        return (!empty($failureMap) ? $failureMap : true);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param string $name name
     * @param string $type The type of fieldname the $name is of:
     *               one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *               BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *               Defaults to BasePeer::TYPE_PHPNAME
     * @return mixed Value of field.
     */
    public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = LohnprofilPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getMod();
                break;
            case 2:
                return $this->getName();
                break;
            case 3:
                return $this->getPeriode();
                break;
            case 4:
                return $this->getLohnsteuer();
                break;
            case 5:
                return $this->getKirchensteuerRk();
                break;
            case 6:
                return $this->getKirchensteuerEv();
                break;
            case 7:
                return $this->getSoli();
                break;
            case 8:
                return $this->getRentenversicherungAn();
                break;
            case 9:
                return $this->getRentenversicherungAg();
                break;
            case 10:
                return $this->getKrankenversicherungAn();
                break;
            case 11:
                return $this->getKrankenversicherungAg();
                break;
            case 12:
                return $this->getU1();
                break;
            case 13:
                return $this->getU2();
                break;
            case 14:
                return $this->getInso();
                break;
            case 15:
                return $this->getPauschalsteuer();
                break;
            case 16:
                return $this->getLaTyp();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     *                    BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                    Defaults to BasePeer::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to true.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = BasePeer::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {
        if (isset($alreadyDumpedObjects['Lohnprofil'][$this->getPrimaryKey()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['Lohnprofil'][$this->getPrimaryKey()] = true;
        $keys = LohnprofilPeer::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getMod(),
            $keys[2] => $this->getName(),
            $keys[3] => $this->getPeriode(),
            $keys[4] => $this->getLohnsteuer(),
            $keys[5] => $this->getKirchensteuerRk(),
            $keys[6] => $this->getKirchensteuerEv(),
            $keys[7] => $this->getSoli(),
            $keys[8] => $this->getRentenversicherungAn(),
            $keys[9] => $this->getRentenversicherungAg(),
            $keys[10] => $this->getKrankenversicherungAn(),
            $keys[11] => $this->getKrankenversicherungAg(),
            $keys[12] => $this->getU1(),
            $keys[13] => $this->getU2(),
            $keys[14] => $this->getInso(),
            $keys[15] => $this->getPauschalsteuer(),
            $keys[16] => $this->getLaTyp(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->collLAs) {
                $result['LAs'] = $this->collLAs->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collMAs) {
                $result['MAs'] = $this->collMAs->toArray(null, true, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param string $name peer name
     * @param mixed $value field value
     * @param string $type The type of fieldname the $name is of:
     *                     one of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                     BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     *                     Defaults to BasePeer::TYPE_PHPNAME
     * @return void
     */
    public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
    {
        $pos = LohnprofilPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);

        $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param int $pos position in xml schema
     * @param mixed $value field value
     * @return void
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setMod($value);
                break;
            case 2:
                $this->setName($value);
                break;
            case 3:
                $this->setPeriode($value);
                break;
            case 4:
                $this->setLohnsteuer($value);
                break;
            case 5:
                $this->setKirchensteuerRk($value);
                break;
            case 6:
                $this->setKirchensteuerEv($value);
                break;
            case 7:
                $this->setSoli($value);
                break;
            case 8:
                $this->setRentenversicherungAn($value);
                break;
            case 9:
                $this->setRentenversicherungAg($value);
                break;
            case 10:
                $this->setKrankenversicherungAn($value);
                break;
            case 11:
                $this->setKrankenversicherungAg($value);
                break;
            case 12:
                $this->setU1($value);
                break;
            case 13:
                $this->setU2($value);
                break;
            case 14:
                $this->setInso($value);
                break;
            case 15:
                $this->setPauschalsteuer($value);
                break;
            case 16:
                $this->setLaTyp($value);
                break;
        } // switch()
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME,
     * BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM.
     * The default key type is the column's BasePeer::TYPE_PHPNAME
     *
     * @param array  $arr     An array to populate the object from.
     * @param string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
    {
        $keys = LohnprofilPeer::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
        if (array_key_exists($keys[1], $arr)) $this->setMod($arr[$keys[1]]);
        if (array_key_exists($keys[2], $arr)) $this->setName($arr[$keys[2]]);
        if (array_key_exists($keys[3], $arr)) $this->setPeriode($arr[$keys[3]]);
        if (array_key_exists($keys[4], $arr)) $this->setLohnsteuer($arr[$keys[4]]);
        if (array_key_exists($keys[5], $arr)) $this->setKirchensteuerRk($arr[$keys[5]]);
        if (array_key_exists($keys[6], $arr)) $this->setKirchensteuerEv($arr[$keys[6]]);
        if (array_key_exists($keys[7], $arr)) $this->setSoli($arr[$keys[7]]);
        if (array_key_exists($keys[8], $arr)) $this->setRentenversicherungAn($arr[$keys[8]]);
        if (array_key_exists($keys[9], $arr)) $this->setRentenversicherungAg($arr[$keys[9]]);
        if (array_key_exists($keys[10], $arr)) $this->setKrankenversicherungAn($arr[$keys[10]]);
        if (array_key_exists($keys[11], $arr)) $this->setKrankenversicherungAg($arr[$keys[11]]);
        if (array_key_exists($keys[12], $arr)) $this->setU1($arr[$keys[12]]);
        if (array_key_exists($keys[13], $arr)) $this->setU2($arr[$keys[13]]);
        if (array_key_exists($keys[14], $arr)) $this->setInso($arr[$keys[14]]);
        if (array_key_exists($keys[15], $arr)) $this->setPauschalsteuer($arr[$keys[15]]);
        if (array_key_exists($keys[16], $arr)) $this->setLaTyp($arr[$keys[16]]);
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(LohnprofilPeer::DATABASE_NAME);

        if ($this->isColumnModified(LohnprofilPeer::ID)) $criteria->add(LohnprofilPeer::ID, $this->id);
        if ($this->isColumnModified(LohnprofilPeer::MOD)) $criteria->add(LohnprofilPeer::MOD, $this->mod);
        if ($this->isColumnModified(LohnprofilPeer::NAME)) $criteria->add(LohnprofilPeer::NAME, $this->name);
        if ($this->isColumnModified(LohnprofilPeer::PERIODE)) $criteria->add(LohnprofilPeer::PERIODE, $this->periode);
        if ($this->isColumnModified(LohnprofilPeer::LOHNSTEUER)) $criteria->add(LohnprofilPeer::LOHNSTEUER, $this->lohnsteuer);
        if ($this->isColumnModified(LohnprofilPeer::KIRCHENSTEUER_RK)) $criteria->add(LohnprofilPeer::KIRCHENSTEUER_RK, $this->kirchensteuer_rk);
        if ($this->isColumnModified(LohnprofilPeer::KIRCHENSTEUER_EV)) $criteria->add(LohnprofilPeer::KIRCHENSTEUER_EV, $this->kirchensteuer_ev);
        if ($this->isColumnModified(LohnprofilPeer::SOLI)) $criteria->add(LohnprofilPeer::SOLI, $this->soli);
        if ($this->isColumnModified(LohnprofilPeer::RENTENVERSICHERUNG_AN)) $criteria->add(LohnprofilPeer::RENTENVERSICHERUNG_AN, $this->rentenversicherung_an);
        if ($this->isColumnModified(LohnprofilPeer::RENTENVERSICHERUNG_AG)) $criteria->add(LohnprofilPeer::RENTENVERSICHERUNG_AG, $this->rentenversicherung_ag);
        if ($this->isColumnModified(LohnprofilPeer::KRANKENVERSICHERUNG_AN)) $criteria->add(LohnprofilPeer::KRANKENVERSICHERUNG_AN, $this->krankenversicherung_an);
        if ($this->isColumnModified(LohnprofilPeer::KRANKENVERSICHERUNG_AG)) $criteria->add(LohnprofilPeer::KRANKENVERSICHERUNG_AG, $this->krankenversicherung_ag);
        if ($this->isColumnModified(LohnprofilPeer::U1)) $criteria->add(LohnprofilPeer::U1, $this->u1);
        if ($this->isColumnModified(LohnprofilPeer::U2)) $criteria->add(LohnprofilPeer::U2, $this->u2);
        if ($this->isColumnModified(LohnprofilPeer::INSO)) $criteria->add(LohnprofilPeer::INSO, $this->inso);
        if ($this->isColumnModified(LohnprofilPeer::PAUSCHALSTEUER)) $criteria->add(LohnprofilPeer::PAUSCHALSTEUER, $this->pauschalsteuer);
        if ($this->isColumnModified(LohnprofilPeer::LA_TYP)) $criteria->add(LohnprofilPeer::LA_TYP, $this->la_typ);

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = new Criteria(LohnprofilPeer::DATABASE_NAME);
        $criteria->add(LohnprofilPeer::ID, $this->id);

        return $criteria;
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param  int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {

        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param object $copyObj An object of Lohnprofil (or compatible) type.
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setMod($this->getMod());
        $copyObj->setName($this->getName());
        $copyObj->setPeriode($this->getPeriode());
        $copyObj->setLohnsteuer($this->getLohnsteuer());
        $copyObj->setKirchensteuerRk($this->getKirchensteuerRk());
        $copyObj->setKirchensteuerEv($this->getKirchensteuerEv());
        $copyObj->setSoli($this->getSoli());
        $copyObj->setRentenversicherungAn($this->getRentenversicherungAn());
        $copyObj->setRentenversicherungAg($this->getRentenversicherungAg());
        $copyObj->setKrankenversicherungAn($this->getKrankenversicherungAn());
        $copyObj->setKrankenversicherungAg($this->getKrankenversicherungAg());
        $copyObj->setU1($this->getU1());
        $copyObj->setU2($this->getU2());
        $copyObj->setInso($this->getInso());
        $copyObj->setPauschalsteuer($this->getPauschalsteuer());
        $copyObj->setLaTyp($this->getLaTyp());

        if ($deepCopy && !$this->startCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);
            // store object hash to prevent cycle
            $this->startCopy = true;

            foreach ($this->getLAs() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addLA($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getMAs() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addMA($relObj->copy($deepCopy));
                }
            }

            //unflag object copy
            $this->startCopy = false;
        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return Lohnprofil Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Returns a peer instance associated with this om.
     *
     * Since Peer classes are not to have any instance attributes, this method returns the
     * same instance for all member of this class. The method could therefore
     * be static, but this would prevent one from overriding the behavior.
     *
     * @return LohnprofilPeer
     */
    public function getPeer()
    {
        if (self::$peer === null) {
            self::$peer = new LohnprofilPeer();
        }

        return self::$peer;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('LA' == $relationName) {
            $this->initLAs();
        }
        if ('MA' == $relationName) {
            $this->initMAs();
        }
    }

    /**
     * Clears out the collLAs collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return Lohnprofil The current object (for fluent API support)
     * @see        addLAs()
     */
    public function clearLAs()
    {
        $this->collLAs = null; // important to set this to null since that means it is uninitialized
        $this->collLAsPartial = null;

        return $this;
    }

    /**
     * reset is the collLAs collection loaded partially
     *
     * @return void
     */
    public function resetPartialLAs($v = true)
    {
        $this->collLAsPartial = $v;
    }

    /**
     * Initializes the collLAs collection.
     *
     * By default this just sets the collLAs collection to an empty array (like clearcollLAs());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initLAs($overrideExisting = true)
    {
        if (null !== $this->collLAs && !$overrideExisting) {
            return;
        }
        $this->collLAs = new PropelObjectCollection();
        $this->collLAs->setModel('Lohnabrechnung');
    }

    /**
     * Gets an array of Lohnabrechnung objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this Lohnprofil is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|Lohnabrechnung[] List of Lohnabrechnung objects
     * @throws PropelException
     */
    public function getLAs($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collLAsPartial && !$this->isNew();
        if (null === $this->collLAs || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collLAs) {
                // return empty collection
                $this->initLAs();
            } else {
                $collLAs = LohnabrechnungQuery::create(null, $criteria)
                    ->filterByLohnprofil($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collLAsPartial && count($collLAs)) {
                      $this->initLAs(false);

                      foreach ($collLAs as $obj) {
                        if (false == $this->collLAs->contains($obj)) {
                          $this->collLAs->append($obj);
                        }
                      }

                      $this->collLAsPartial = true;
                    }

                    $collLAs->getInternalIterator()->rewind();

                    return $collLAs;
                }

                if ($partial && $this->collLAs) {
                    foreach ($this->collLAs as $obj) {
                        if ($obj->isNew()) {
                            $collLAs[] = $obj;
                        }
                    }
                }

                $this->collLAs = $collLAs;
                $this->collLAsPartial = false;
            }
        }

        return $this->collLAs;
    }

    /**
     * Sets a collection of LA objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $lAs A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setLAs(PropelCollection $lAs, PropelPDO $con = null)
    {
        $lAsToDelete = $this->getLAs(new Criteria(), $con)->diff($lAs);


        $this->lAsScheduledForDeletion = $lAsToDelete;

        foreach ($lAsToDelete as $lARemoved) {
            $lARemoved->setLohnprofil(null);
        }

        $this->collLAs = null;
        foreach ($lAs as $lA) {
            $this->addLA($lA);
        }

        $this->collLAs = $lAs;
        $this->collLAsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related Lohnabrechnung objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related Lohnabrechnung objects.
     * @throws PropelException
     */
    public function countLAs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collLAsPartial && !$this->isNew();
        if (null === $this->collLAs || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collLAs) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getLAs());
            }
            $query = LohnabrechnungQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByLohnprofil($this)
                ->count($con);
        }

        return count($this->collLAs);
    }

    /**
     * Method called to associate a BaseLohnabrechnung object to this object
     * through the BaseLohnabrechnung foreign key attribute.
     *
     * @param    BaseLohnabrechnung $l BaseLohnabrechnung
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function addLA(BaseLohnabrechnung $l)
    {
        if ($this->collLAs === null) {
            $this->initLAs();
            $this->collLAsPartial = true;
        }

        if (!in_array($l, $this->collLAs->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddLA($l);

            if ($this->lAsScheduledForDeletion and $this->lAsScheduledForDeletion->contains($l)) {
                $this->lAsScheduledForDeletion->remove($this->lAsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	LA $lA The lA object to add.
     */
    protected function doAddLA($lA)
    {
        $this->collLAs[]= $lA;
        $lA->setLohnprofil($this);
    }

    /**
     * @param	LA $lA The lA object to remove.
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function removeLA($lA)
    {
        if ($this->getLAs()->contains($lA)) {
            $this->collLAs->remove($this->collLAs->search($lA));
            if (null === $this->lAsScheduledForDeletion) {
                $this->lAsScheduledForDeletion = clone $this->collLAs;
                $this->lAsScheduledForDeletion->clear();
            }
            $this->lAsScheduledForDeletion[]= clone $lA;
            $lA->setLohnprofil(null);
        }

        return $this;
    }


    /**
     * If this collection has already been initialized with
     * an identical criteria, it returns the collection.
     * Otherwise if this Lohnprofil is new, it will return
     * an empty collection; or if this Lohnprofil has previously
     * been saved, it will retrieve related LAs from storage.
     *
     * This method is protected by default in order to keep the public
     * api reasonable.  You can provide public methods for those you
     * actually need in Lohnprofil.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @param string $join_behavior optional join type to use (defaults to Criteria::LEFT_JOIN)
     * @return PropelObjectCollection|Lohnabrechnung[] List of Lohnabrechnung objects
     */
    public function getLAsJoinMitarbeiter($criteria = null, $con = null, $join_behavior = Criteria::LEFT_JOIN)
    {
        $query = LohnabrechnungQuery::create(null, $criteria);
        $query->joinWith('Mitarbeiter', $join_behavior);

        return $this->getLAs($query, $con);
    }

    /**
     * Clears out the collMAs collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return Lohnprofil The current object (for fluent API support)
     * @see        addMAs()
     */
    public function clearMAs()
    {
        $this->collMAs = null; // important to set this to null since that means it is uninitialized
        $this->collMAsPartial = null;

        return $this;
    }

    /**
     * reset is the collMAs collection loaded partially
     *
     * @return void
     */
    public function resetPartialMAs($v = true)
    {
        $this->collMAsPartial = $v;
    }

    /**
     * Initializes the collMAs collection.
     *
     * By default this just sets the collMAs collection to an empty array (like clearcollMAs());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initMAs($overrideExisting = true)
    {
        if (null !== $this->collMAs && !$overrideExisting) {
            return;
        }
        $this->collMAs = new PropelObjectCollection();
        $this->collMAs->setModel('Mitarbeiter');
    }

    /**
     * Gets an array of Mitarbeiter objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this Lohnprofil is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param Criteria $criteria optional Criteria object to narrow the query
     * @param PropelPDO $con optional connection object
     * @return PropelObjectCollection|Mitarbeiter[] List of Mitarbeiter objects
     * @throws PropelException
     */
    public function getMAs($criteria = null, PropelPDO $con = null)
    {
        $partial = $this->collMAsPartial && !$this->isNew();
        if (null === $this->collMAs || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collMAs) {
                // return empty collection
                $this->initMAs();
            } else {
                $collMAs = MitarbeiterQuery::create(null, $criteria)
                    ->filterByLohnprofil($this)
                    ->find($con);
                if (null !== $criteria) {
                    if (false !== $this->collMAsPartial && count($collMAs)) {
                      $this->initMAs(false);

                      foreach ($collMAs as $obj) {
                        if (false == $this->collMAs->contains($obj)) {
                          $this->collMAs->append($obj);
                        }
                      }

                      $this->collMAsPartial = true;
                    }

                    $collMAs->getInternalIterator()->rewind();

                    return $collMAs;
                }

                if ($partial && $this->collMAs) {
                    foreach ($this->collMAs as $obj) {
                        if ($obj->isNew()) {
                            $collMAs[] = $obj;
                        }
                    }
                }

                $this->collMAs = $collMAs;
                $this->collMAsPartial = false;
            }
        }

        return $this->collMAs;
    }

    /**
     * Sets a collection of MA objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param PropelCollection $mAs A Propel collection.
     * @param PropelPDO $con Optional connection object
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function setMAs(PropelCollection $mAs, PropelPDO $con = null)
    {
        $mAsToDelete = $this->getMAs(new Criteria(), $con)->diff($mAs);


        $this->mAsScheduledForDeletion = $mAsToDelete;

        foreach ($mAsToDelete as $mARemoved) {
            $mARemoved->setLohnprofil(null);
        }

        $this->collMAs = null;
        foreach ($mAs as $mA) {
            $this->addMA($mA);
        }

        $this->collMAs = $mAs;
        $this->collMAsPartial = false;

        return $this;
    }

    /**
     * Returns the number of related Mitarbeiter objects.
     *
     * @param Criteria $criteria
     * @param boolean $distinct
     * @param PropelPDO $con
     * @return int             Count of related Mitarbeiter objects.
     * @throws PropelException
     */
    public function countMAs(Criteria $criteria = null, $distinct = false, PropelPDO $con = null)
    {
        $partial = $this->collMAsPartial && !$this->isNew();
        if (null === $this->collMAs || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collMAs) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getMAs());
            }
            $query = MitarbeiterQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByLohnprofil($this)
                ->count($con);
        }

        return count($this->collMAs);
    }

    /**
     * Method called to associate a Mitarbeiter object to this object
     * through the Mitarbeiter foreign key attribute.
     *
     * @param    Mitarbeiter $l Mitarbeiter
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function addMA(Mitarbeiter $l)
    {
        if ($this->collMAs === null) {
            $this->initMAs();
            $this->collMAsPartial = true;
        }

        if (!in_array($l, $this->collMAs->getArrayCopy(), true)) { // only add it if the **same** object is not already associated
            $this->doAddMA($l);

            if ($this->mAsScheduledForDeletion and $this->mAsScheduledForDeletion->contains($l)) {
                $this->mAsScheduledForDeletion->remove($this->mAsScheduledForDeletion->search($l));
            }
        }

        return $this;
    }

    /**
     * @param	MA $mA The mA object to add.
     */
    protected function doAddMA($mA)
    {
        $this->collMAs[]= $mA;
        $mA->setLohnprofil($this);
    }

    /**
     * @param	MA $mA The mA object to remove.
     * @return Lohnprofil The current object (for fluent API support)
     */
    public function removeMA($mA)
    {
        if ($this->getMAs()->contains($mA)) {
            $this->collMAs->remove($this->collMAs->search($mA));
            if (null === $this->mAsScheduledForDeletion) {
                $this->mAsScheduledForDeletion = clone $this->collMAs;
                $this->mAsScheduledForDeletion->clear();
            }
            $this->mAsScheduledForDeletion[]= clone $mA;
            $mA->setLohnprofil(null);
        }

        return $this;
    }

    /**
     * Clears the current object and sets all attributes to their default values
     */
    public function clear()
    {
        $this->id = null;
        $this->mod = null;
        $this->name = null;
        $this->periode = null;
        $this->lohnsteuer = null;
        $this->kirchensteuer_rk = null;
        $this->kirchensteuer_ev = null;
        $this->soli = null;
        $this->rentenversicherung_an = null;
        $this->rentenversicherung_ag = null;
        $this->krankenversicherung_an = null;
        $this->krankenversicherung_ag = null;
        $this->u1 = null;
        $this->u2 = null;
        $this->inso = null;
        $this->pauschalsteuer = null;
        $this->la_typ = null;
        $this->alreadyInSave = false;
        $this->alreadyInValidation = false;
        $this->alreadyInClearAllReferencesDeep = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references to other model objects or collections of model objects.
     *
     * This method is a user-space workaround for PHP's inability to garbage collect
     * objects with circular references (even in PHP 5.3). This is currently necessary
     * when using Propel in certain daemon or large-volume/high-memory operations.
     *
     * @param boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep && !$this->alreadyInClearAllReferencesDeep) {
            $this->alreadyInClearAllReferencesDeep = true;
            if ($this->collLAs) {
                foreach ($this->collLAs as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collMAs) {
                foreach ($this->collMAs as $o) {
                    $o->clearAllReferences($deep);
                }
            }

            $this->alreadyInClearAllReferencesDeep = false;
        } // if ($deep)

        if ($this->collLAs instanceof PropelCollection) {
            $this->collLAs->clearIterator();
        }
        $this->collLAs = null;
        if ($this->collMAs instanceof PropelCollection) {
            $this->collMAs->clearIterator();
        }
        $this->collMAs = null;
    }

    /**
     * return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(LohnprofilPeer::DEFAULT_STRING_FORMAT);
    }

    /**
     * return true is the object is in saving state
     *
     * @return boolean
     */
    public function isAlreadyInSave()
    {
        return $this->alreadyInSave;
    }

}
