<?php


/**
 * Base static class for performing query and update operations on the 'lohnprofil' table.
 *
 *
 *
 * @package propel.generator.propel.om
 */
abstract class BaseLohnprofilPeer
{

    /** the default database name for this class */
    const DATABASE_NAME = 'mlohn';

    /** the table name for this class */
    const TABLE_NAME = 'lohnprofil';

    /** the related Propel class for this table */
    const OM_CLASS = 'Lohnprofil';

    /** the related TableMap class for this table */
    const TM_CLASS = 'LohnprofilTableMap';

    /** The total number of columns. */
    const NUM_COLUMNS = 17;

    /** The number of lazy-loaded columns. */
    const NUM_LAZY_LOAD_COLUMNS = 0;

    /** The number of columns to hydrate (NUM_COLUMNS - NUM_LAZY_LOAD_COLUMNS) */
    const NUM_HYDRATE_COLUMNS = 17;

    /** the column name for the id field */
    const ID = 'lohnprofil.id';

    /** the column name for the mod field */
    const MOD = 'lohnprofil.mod';

    /** the column name for the name field */
    const NAME = 'lohnprofil.name';

    /** the column name for the periode field */
    const PERIODE = 'lohnprofil.periode';

    /** the column name for the lohnsteuer field */
    const LOHNSTEUER = 'lohnprofil.lohnsteuer';

    /** the column name for the kirchensteuer_rk field */
    const KIRCHENSTEUER_RK = 'lohnprofil.kirchensteuer_rk';

    /** the column name for the kirchensteuer_ev field */
    const KIRCHENSTEUER_EV = 'lohnprofil.kirchensteuer_ev';

    /** the column name for the soli field */
    const SOLI = 'lohnprofil.soli';

    /** the column name for the rentenversicherung_an field */
    const RENTENVERSICHERUNG_AN = 'lohnprofil.rentenversicherung_an';

    /** the column name for the rentenversicherung_ag field */
    const RENTENVERSICHERUNG_AG = 'lohnprofil.rentenversicherung_ag';

    /** the column name for the krankenversicherung_an field */
    const KRANKENVERSICHERUNG_AN = 'lohnprofil.krankenversicherung_an';

    /** the column name for the krankenversicherung_ag field */
    const KRANKENVERSICHERUNG_AG = 'lohnprofil.krankenversicherung_ag';

    /** the column name for the u1 field */
    const U1 = 'lohnprofil.u1';

    /** the column name for the u2 field */
    const U2 = 'lohnprofil.u2';

    /** the column name for the inso field */
    const INSO = 'lohnprofil.inso';

    /** the column name for the pauschalsteuer field */
    const PAUSCHALSTEUER = 'lohnprofil.pauschalsteuer';

    /** the column name for the la_typ field */
    const LA_TYP = 'lohnprofil.la_typ';

    /** The default string format for model objects of the related table **/
    const DEFAULT_STRING_FORMAT = 'YAML';

    /**
     * An identity map to hold any loaded instances of Lohnprofil objects.
     * This must be public so that other peer classes can access this when hydrating from JOIN
     * queries.
     * @var        array Lohnprofil[]
     */
    public static $instances = array();


    /**
     * holds an array of fieldnames
     *
     * first dimension keys are the type constants
     * e.g. LohnprofilPeer::$fieldNames[LohnprofilPeer::TYPE_PHPNAME][0] = 'Id'
     */
    protected static $fieldNames = array (
        BasePeer::TYPE_PHPNAME => array ('Id', 'Mod', 'Name', 'Periode', 'Lohnsteuer', 'KirchensteuerRk', 'KirchensteuerEv', 'Soli', 'RentenversicherungAn', 'RentenversicherungAg', 'KrankenversicherungAn', 'KrankenversicherungAg', 'U1', 'U2', 'Inso', 'Pauschalsteuer', 'LaTyp', ),
        BasePeer::TYPE_STUDLYPHPNAME => array ('id', 'mod', 'name', 'periode', 'lohnsteuer', 'kirchensteuerRk', 'kirchensteuerEv', 'soli', 'rentenversicherungAn', 'rentenversicherungAg', 'krankenversicherungAn', 'krankenversicherungAg', 'u1', 'u2', 'inso', 'pauschalsteuer', 'laTyp', ),
        BasePeer::TYPE_COLNAME => array (LohnprofilPeer::ID, LohnprofilPeer::MOD, LohnprofilPeer::NAME, LohnprofilPeer::PERIODE, LohnprofilPeer::LOHNSTEUER, LohnprofilPeer::KIRCHENSTEUER_RK, LohnprofilPeer::KIRCHENSTEUER_EV, LohnprofilPeer::SOLI, LohnprofilPeer::RENTENVERSICHERUNG_AN, LohnprofilPeer::RENTENVERSICHERUNG_AG, LohnprofilPeer::KRANKENVERSICHERUNG_AN, LohnprofilPeer::KRANKENVERSICHERUNG_AG, LohnprofilPeer::U1, LohnprofilPeer::U2, LohnprofilPeer::INSO, LohnprofilPeer::PAUSCHALSTEUER, LohnprofilPeer::LA_TYP, ),
        BasePeer::TYPE_RAW_COLNAME => array ('ID', 'MOD', 'NAME', 'PERIODE', 'LOHNSTEUER', 'KIRCHENSTEUER_RK', 'KIRCHENSTEUER_EV', 'SOLI', 'RENTENVERSICHERUNG_AN', 'RENTENVERSICHERUNG_AG', 'KRANKENVERSICHERUNG_AN', 'KRANKENVERSICHERUNG_AG', 'U1', 'U2', 'INSO', 'PAUSCHALSTEUER', 'LA_TYP', ),
        BasePeer::TYPE_FIELDNAME => array ('id', 'mod', 'name', 'periode', 'lohnsteuer', 'kirchensteuer_rk', 'kirchensteuer_ev', 'soli', 'rentenversicherung_an', 'rentenversicherung_ag', 'krankenversicherung_an', 'krankenversicherung_ag', 'u1', 'u2', 'inso', 'pauschalsteuer', 'la_typ', ),
        BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, )
    );

    /**
     * holds an array of keys for quick access to the fieldnames array
     *
     * first dimension keys are the type constants
     * e.g. LohnprofilPeer::$fieldNames[BasePeer::TYPE_PHPNAME]['Id'] = 0
     */
    protected static $fieldKeys = array (
        BasePeer::TYPE_PHPNAME => array ('Id' => 0, 'Mod' => 1, 'Name' => 2, 'Periode' => 3, 'Lohnsteuer' => 4, 'KirchensteuerRk' => 5, 'KirchensteuerEv' => 6, 'Soli' => 7, 'RentenversicherungAn' => 8, 'RentenversicherungAg' => 9, 'KrankenversicherungAn' => 10, 'KrankenversicherungAg' => 11, 'U1' => 12, 'U2' => 13, 'Inso' => 14, 'Pauschalsteuer' => 15, 'LaTyp' => 16, ),
        BasePeer::TYPE_STUDLYPHPNAME => array ('id' => 0, 'mod' => 1, 'name' => 2, 'periode' => 3, 'lohnsteuer' => 4, 'kirchensteuerRk' => 5, 'kirchensteuerEv' => 6, 'soli' => 7, 'rentenversicherungAn' => 8, 'rentenversicherungAg' => 9, 'krankenversicherungAn' => 10, 'krankenversicherungAg' => 11, 'u1' => 12, 'u2' => 13, 'inso' => 14, 'pauschalsteuer' => 15, 'laTyp' => 16, ),
        BasePeer::TYPE_COLNAME => array (LohnprofilPeer::ID => 0, LohnprofilPeer::MOD => 1, LohnprofilPeer::NAME => 2, LohnprofilPeer::PERIODE => 3, LohnprofilPeer::LOHNSTEUER => 4, LohnprofilPeer::KIRCHENSTEUER_RK => 5, LohnprofilPeer::KIRCHENSTEUER_EV => 6, LohnprofilPeer::SOLI => 7, LohnprofilPeer::RENTENVERSICHERUNG_AN => 8, LohnprofilPeer::RENTENVERSICHERUNG_AG => 9, LohnprofilPeer::KRANKENVERSICHERUNG_AN => 10, LohnprofilPeer::KRANKENVERSICHERUNG_AG => 11, LohnprofilPeer::U1 => 12, LohnprofilPeer::U2 => 13, LohnprofilPeer::INSO => 14, LohnprofilPeer::PAUSCHALSTEUER => 15, LohnprofilPeer::LA_TYP => 16, ),
        BasePeer::TYPE_RAW_COLNAME => array ('ID' => 0, 'MOD' => 1, 'NAME' => 2, 'PERIODE' => 3, 'LOHNSTEUER' => 4, 'KIRCHENSTEUER_RK' => 5, 'KIRCHENSTEUER_EV' => 6, 'SOLI' => 7, 'RENTENVERSICHERUNG_AN' => 8, 'RENTENVERSICHERUNG_AG' => 9, 'KRANKENVERSICHERUNG_AN' => 10, 'KRANKENVERSICHERUNG_AG' => 11, 'U1' => 12, 'U2' => 13, 'INSO' => 14, 'PAUSCHALSTEUER' => 15, 'LA_TYP' => 16, ),
        BasePeer::TYPE_FIELDNAME => array ('id' => 0, 'mod' => 1, 'name' => 2, 'periode' => 3, 'lohnsteuer' => 4, 'kirchensteuer_rk' => 5, 'kirchensteuer_ev' => 6, 'soli' => 7, 'rentenversicherung_an' => 8, 'rentenversicherung_ag' => 9, 'krankenversicherung_an' => 10, 'krankenversicherung_ag' => 11, 'u1' => 12, 'u2' => 13, 'inso' => 14, 'pauschalsteuer' => 15, 'la_typ' => 16, ),
        BasePeer::TYPE_NUM => array (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, )
    );

    /**
     * Translates a fieldname to another type
     *
     * @param      string $name field name
     * @param      string $fromType One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                         BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     * @param      string $toType   One of the class type constants
     * @return string          translated name of the field.
     * @throws PropelException - if the specified name could not be found in the fieldname mappings.
     */
    public static function translateFieldName($name, $fromType, $toType)
    {
        $toNames = LohnprofilPeer::getFieldNames($toType);
        $key = isset(LohnprofilPeer::$fieldKeys[$fromType][$name]) ? LohnprofilPeer::$fieldKeys[$fromType][$name] : null;
        if ($key === null) {
            throw new PropelException("'$name' could not be found in the field names of type '$fromType'. These are: " . print_r(LohnprofilPeer::$fieldKeys[$fromType], true));
        }

        return $toNames[$key];
    }

    /**
     * Returns an array of field names.
     *
     * @param      string $type The type of fieldnames to return:
     *                      One of the class type constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME
     *                      BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM
     * @return array           A list of field names
     * @throws PropelException - if the type is not valid.
     */
    public static function getFieldNames($type = BasePeer::TYPE_PHPNAME)
    {
        if (!array_key_exists($type, LohnprofilPeer::$fieldNames)) {
            throw new PropelException('Method getFieldNames() expects the parameter $type to be one of the class constants BasePeer::TYPE_PHPNAME, BasePeer::TYPE_STUDLYPHPNAME, BasePeer::TYPE_COLNAME, BasePeer::TYPE_FIELDNAME, BasePeer::TYPE_NUM. ' . $type . ' was given.');
        }

        return LohnprofilPeer::$fieldNames[$type];
    }

    /**
     * Convenience method which changes table.column to alias.column.
     *
     * Using this method you can maintain SQL abstraction while using column aliases.
     * <code>
     *		$c->addAlias("alias1", TablePeer::TABLE_NAME);
     *		$c->addJoin(TablePeer::alias("alias1", TablePeer::PRIMARY_KEY_COLUMN), TablePeer::PRIMARY_KEY_COLUMN);
     * </code>
     * @param      string $alias The alias for the current table.
     * @param      string $column The column name for current table. (i.e. LohnprofilPeer::COLUMN_NAME).
     * @return string
     */
    public static function alias($alias, $column)
    {
        return str_replace(LohnprofilPeer::TABLE_NAME.'.', $alias.'.', $column);
    }

    /**
     * Add all the columns needed to create a new object.
     *
     * Note: any columns that were marked with lazyLoad="true" in the
     * XML schema will not be added to the select list and only loaded
     * on demand.
     *
     * @param      Criteria $criteria object containing the columns to add.
     * @param      string   $alias    optional table alias
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function addSelectColumns(Criteria $criteria, $alias = null)
    {
        if (null === $alias) {
            $criteria->addSelectColumn(LohnprofilPeer::ID);
            $criteria->addSelectColumn(LohnprofilPeer::MOD);
            $criteria->addSelectColumn(LohnprofilPeer::NAME);
            $criteria->addSelectColumn(LohnprofilPeer::PERIODE);
            $criteria->addSelectColumn(LohnprofilPeer::LOHNSTEUER);
            $criteria->addSelectColumn(LohnprofilPeer::KIRCHENSTEUER_RK);
            $criteria->addSelectColumn(LohnprofilPeer::KIRCHENSTEUER_EV);
            $criteria->addSelectColumn(LohnprofilPeer::SOLI);
            $criteria->addSelectColumn(LohnprofilPeer::RENTENVERSICHERUNG_AN);
            $criteria->addSelectColumn(LohnprofilPeer::RENTENVERSICHERUNG_AG);
            $criteria->addSelectColumn(LohnprofilPeer::KRANKENVERSICHERUNG_AN);
            $criteria->addSelectColumn(LohnprofilPeer::KRANKENVERSICHERUNG_AG);
            $criteria->addSelectColumn(LohnprofilPeer::U1);
            $criteria->addSelectColumn(LohnprofilPeer::U2);
            $criteria->addSelectColumn(LohnprofilPeer::INSO);
            $criteria->addSelectColumn(LohnprofilPeer::PAUSCHALSTEUER);
            $criteria->addSelectColumn(LohnprofilPeer::LA_TYP);
        } else {
            $criteria->addSelectColumn($alias . '.id');
            $criteria->addSelectColumn($alias . '.mod');
            $criteria->addSelectColumn($alias . '.name');
            $criteria->addSelectColumn($alias . '.periode');
            $criteria->addSelectColumn($alias . '.lohnsteuer');
            $criteria->addSelectColumn($alias . '.kirchensteuer_rk');
            $criteria->addSelectColumn($alias . '.kirchensteuer_ev');
            $criteria->addSelectColumn($alias . '.soli');
            $criteria->addSelectColumn($alias . '.rentenversicherung_an');
            $criteria->addSelectColumn($alias . '.rentenversicherung_ag');
            $criteria->addSelectColumn($alias . '.krankenversicherung_an');
            $criteria->addSelectColumn($alias . '.krankenversicherung_ag');
            $criteria->addSelectColumn($alias . '.u1');
            $criteria->addSelectColumn($alias . '.u2');
            $criteria->addSelectColumn($alias . '.inso');
            $criteria->addSelectColumn($alias . '.pauschalsteuer');
            $criteria->addSelectColumn($alias . '.la_typ');
        }
    }

    /**
     * Returns the number of rows matching criteria.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct Whether to select only distinct columns; deprecated: use Criteria->setDistinct() instead.
     * @param      PropelPDO $con
     * @return int Number of matching rows.
     */
    public static function doCount(Criteria $criteria, $distinct = false, PropelPDO $con = null)
    {
        // we may modify criteria, so copy it first
        $criteria = clone $criteria;

        // We need to set the primary table name, since in the case that there are no WHERE columns
        // it will be impossible for the BasePeer::createSelectSql() method to determine which
        // tables go into the FROM clause.
        $criteria->setPrimaryTableName(LohnprofilPeer::TABLE_NAME);

        if ($distinct && !in_array(Criteria::DISTINCT, $criteria->getSelectModifiers())) {
            $criteria->setDistinct();
        }

        if (!$criteria->hasSelectClause()) {
            LohnprofilPeer::addSelectColumns($criteria);
        }

        $criteria->clearOrderByColumns(); // ORDER BY won't ever affect the count
        $criteria->setDbName(LohnprofilPeer::DATABASE_NAME); // Set the correct dbName

        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }
        // BasePeer returns a PDOStatement
        $stmt = BasePeer::doCount($criteria, $con);

        if ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $count = (int) $row[0];
        } else {
            $count = 0; // no rows returned; we infer that means 0 matches.
        }
        $stmt->closeCursor();

        return $count;
    }
    /**
     * Selects one object from the DB.
     *
     * @param      Criteria $criteria object used to create the SELECT statement.
     * @param      PropelPDO $con
     * @return Lohnprofil
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelectOne(Criteria $criteria, PropelPDO $con = null)
    {
        $critcopy = clone $criteria;
        $critcopy->setLimit(1);
        $objects = LohnprofilPeer::doSelect($critcopy, $con);
        if ($objects) {
            return $objects[0];
        }

        return null;
    }
    /**
     * Selects several row from the DB.
     *
     * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param      PropelPDO $con
     * @return array           Array of selected Objects
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doSelect(Criteria $criteria, PropelPDO $con = null)
    {
        return LohnprofilPeer::populateObjects(LohnprofilPeer::doSelectStmt($criteria, $con));
    }
    /**
     * Prepares the Criteria object and uses the parent doSelect() method to execute a PDOStatement.
     *
     * Use this method directly if you want to work with an executed statement directly (for example
     * to perform your own object hydration).
     *
     * @param      Criteria $criteria The Criteria object used to build the SELECT statement.
     * @param      PropelPDO $con The connection to use
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     * @return PDOStatement The executed PDOStatement object.
     * @see        BasePeer::doSelect()
     */
    public static function doSelectStmt(Criteria $criteria, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        if (!$criteria->hasSelectClause()) {
            $criteria = clone $criteria;
            LohnprofilPeer::addSelectColumns($criteria);
        }

        // Set the correct dbName
        $criteria->setDbName(LohnprofilPeer::DATABASE_NAME);

        // BasePeer returns a PDOStatement
        return BasePeer::doSelect($criteria, $con);
    }
    /**
     * Adds an object to the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doSelect*()
     * methods in your stub classes -- you may need to explicitly add objects
     * to the cache in order to ensure that the same objects are always returned by doSelect*()
     * and retrieveByPK*() calls.
     *
     * @param Lohnprofil $obj A Lohnprofil object.
     * @param      string $key (optional) key to use for instance map (for performance boost if key was already calculated externally).
     */
    public static function addInstanceToPool($obj, $key = null)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if ($key === null) {
                $key = (string) $obj->getId();
            } // if key === null
            LohnprofilPeer::$instances[$key] = $obj;
        }
    }

    /**
     * Removes an object from the instance pool.
     *
     * Propel keeps cached copies of objects in an instance pool when they are retrieved
     * from the database.  In some cases -- especially when you override doDelete
     * methods in your stub classes -- you may need to explicitly remove objects
     * from the cache in order to prevent returning objects that no longer exist.
     *
     * @param      mixed $value A Lohnprofil object or a primary key value.
     *
     * @return void
     * @throws PropelException - if the value is invalid.
     */
    public static function removeInstanceFromPool($value)
    {
        if (Propel::isInstancePoolingEnabled() && $value !== null) {
            if (is_object($value) && $value instanceof Lohnprofil) {
                $key = (string) $value->getId();
            } elseif (is_scalar($value)) {
                // assume we've been passed a primary key
                $key = (string) $value;
            } else {
                $e = new PropelException("Invalid value passed to removeInstanceFromPool().  Expected primary key or Lohnprofil object; got " . (is_object($value) ? get_class($value) . ' object.' : var_export($value,true)));
                throw $e;
            }

            unset(LohnprofilPeer::$instances[$key]);
        }
    } // removeInstanceFromPool()

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param      string $key The key (@see getPrimaryKeyHash()) for this instance.
     * @return Lohnprofil Found object or null if 1) no instance exists for specified key or 2) instance pooling has been disabled.
     * @see        getPrimaryKeyHash()
     */
    public static function getInstanceFromPool($key)
    {
        if (Propel::isInstancePoolingEnabled()) {
            if (isset(LohnprofilPeer::$instances[$key])) {
                return LohnprofilPeer::$instances[$key];
            }
        }

        return null; // just to be explicit
    }

    /**
     * Clear the instance pool.
     *
     * @return void
     */
    public static function clearInstancePool($and_clear_all_references = false)
    {
      if ($and_clear_all_references) {
        foreach (LohnprofilPeer::$instances as $instance) {
          $instance->clearAllReferences(true);
        }
      }
        LohnprofilPeer::$instances = array();
    }

    /**
     * Method to invalidate the instance pool of all tables related to lohnprofil
     * by a foreign key with ON DELETE CASCADE
     */
    public static function clearRelatedInstancePool()
    {
    }

    /**
     * Retrieves a string version of the primary key from the DB resultset row that can be used to uniquely identify a row in this table.
     *
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, a serialize()d version of the primary key will be returned.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @return string A string version of PK or null if the components of primary key in result array are all null.
     */
    public static function getPrimaryKeyHashFromRow($row, $startcol = 0)
    {
        // If the PK cannot be derived from the row, return null.
        if ($row[$startcol] === null) {
            return null;
        }

        return (string) $row[$startcol];
    }

    /**
     * Retrieves the primary key from the DB resultset row
     * For tables with a single-column primary key, that simple pkey value will be returned.  For tables with
     * a multi-column primary key, an array of the primary key columns will be returned.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @return mixed The primary key of the row
     */
    public static function getPrimaryKeyFromRow($row, $startcol = 0)
    {

        return (int) $row[$startcol];
    }

    /**
     * The returned array will contain objects of the default type or
     * objects that inherit from the default.
     *
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function populateObjects(PDOStatement $stmt)
    {
        $results = array();

        // set the class once to avoid overhead in the loop
        $cls = LohnprofilPeer::getOMClass();
        // populate the object(s)
        while ($row = $stmt->fetch(PDO::FETCH_NUM)) {
            $key = LohnprofilPeer::getPrimaryKeyHashFromRow($row, 0);
            if (null !== ($obj = LohnprofilPeer::getInstanceFromPool($key))) {
                // We no longer rehydrate the object, since this can cause data loss.
                // See http://www.propelorm.org/ticket/509
                // $obj->hydrate($row, 0, true); // rehydrate
                $results[] = $obj;
            } else {
                $obj = new $cls();
                $obj->hydrate($row);
                $results[] = $obj;
                LohnprofilPeer::addInstanceToPool($obj, $key);
            } // if key exists
        }
        $stmt->closeCursor();

        return $results;
    }
    /**
     * Populates an object of the default type or an object that inherit from the default.
     *
     * @param      array $row PropelPDO resultset row.
     * @param      int $startcol The 0-based offset for reading from the resultset row.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     * @return array (Lohnprofil object, last column rank)
     */
    public static function populateObject($row, $startcol = 0)
    {
        $key = LohnprofilPeer::getPrimaryKeyHashFromRow($row, $startcol);
        if (null !== ($obj = LohnprofilPeer::getInstanceFromPool($key))) {
            // We no longer rehydrate the object, since this can cause data loss.
            // See http://www.propelorm.org/ticket/509
            // $obj->hydrate($row, $startcol, true); // rehydrate
            $col = $startcol + LohnprofilPeer::NUM_HYDRATE_COLUMNS;
        } else {
            $cls = LohnprofilPeer::OM_CLASS;
            $obj = new $cls();
            $col = $obj->hydrate($row, $startcol);
            LohnprofilPeer::addInstanceToPool($obj, $key);
        }

        return array($obj, $col);
    }

    /**
     * Returns the TableMap related to this peer.
     * This method is not needed for general use but a specific application could have a need.
     * @return TableMap
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function getTableMap()
    {
        return Propel::getDatabaseMap(LohnprofilPeer::DATABASE_NAME)->getTable(LohnprofilPeer::TABLE_NAME);
    }

    /**
     * Add a TableMap instance to the database for this peer class.
     */
    public static function buildTableMap()
    {
      $dbMap = Propel::getDatabaseMap(BaseLohnprofilPeer::DATABASE_NAME);
      if (!$dbMap->hasTable(BaseLohnprofilPeer::TABLE_NAME)) {
        $dbMap->addTableObject(new \LohnprofilTableMap());
      }
    }

    /**
     * The class that the Peer will make instances of.
     *
     *
     * @return string ClassName
     */
    public static function getOMClass($row = 0, $colnum = 0)
    {
        return LohnprofilPeer::OM_CLASS;
    }

    /**
     * Performs an INSERT on the database, given a Lohnprofil or Criteria object.
     *
     * @param      mixed $values Criteria or Lohnprofil object containing data that is used to create the INSERT statement.
     * @param      PropelPDO $con the PropelPDO connection to use
     * @return mixed           The new primary key.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doInsert($values, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        if ($values instanceof Criteria) {
            $criteria = clone $values; // rename for clarity
        } else {
            $criteria = $values->buildCriteria(); // build Criteria from Lohnprofil object
        }

        if ($criteria->containsKey(LohnprofilPeer::ID) && $criteria->keyContainsValue(LohnprofilPeer::ID) ) {
            throw new PropelException('Cannot insert a value for auto-increment primary key ('.LohnprofilPeer::ID.')');
        }


        // Set the correct dbName
        $criteria->setDbName(LohnprofilPeer::DATABASE_NAME);

        try {
            // use transaction because $criteria could contain info
            // for more than one table (I guess, conceivably)
            $con->beginTransaction();
            $pk = BasePeer::doInsert($criteria, $con);
            $con->commit();
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }

        return $pk;
    }

    /**
     * Performs an UPDATE on the database, given a Lohnprofil or Criteria object.
     *
     * @param      mixed $values Criteria or Lohnprofil object containing data that is used to create the UPDATE statement.
     * @param      PropelPDO $con The connection to use (specify PropelPDO connection object to exert more control over transactions).
     * @return int             The number of affected rows (if supported by underlying database driver).
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function doUpdate($values, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        $selectCriteria = new Criteria(LohnprofilPeer::DATABASE_NAME);

        if ($values instanceof Criteria) {
            $criteria = clone $values; // rename for clarity

            $comparison = $criteria->getComparison(LohnprofilPeer::ID);
            $value = $criteria->remove(LohnprofilPeer::ID);
            if ($value) {
                $selectCriteria->add(LohnprofilPeer::ID, $value, $comparison);
            } else {
                $selectCriteria->setPrimaryTableName(LohnprofilPeer::TABLE_NAME);
            }

        } else { // $values is Lohnprofil object
            $criteria = $values->buildCriteria(); // gets full criteria
            $selectCriteria = $values->buildPkeyCriteria(); // gets criteria w/ primary key(s)
        }

        // set the correct dbName
        $criteria->setDbName(LohnprofilPeer::DATABASE_NAME);

        return BasePeer::doUpdate($selectCriteria, $criteria, $con);
    }

    /**
     * Deletes all rows from the lohnprofil table.
     *
     * @param      PropelPDO $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).
     * @throws PropelException
     */
    public static function doDeleteAll(PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }
        $affectedRows = 0; // initialize var to track total num of affected rows
        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();
            $affectedRows += BasePeer::doDeleteAll(LohnprofilPeer::TABLE_NAME, $con, LohnprofilPeer::DATABASE_NAME);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            LohnprofilPeer::clearInstancePool();
            LohnprofilPeer::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Performs a DELETE on the database, given a Lohnprofil or Criteria object OR a primary key value.
     *
     * @param      mixed $values Criteria or Lohnprofil object or primary key or array of primary keys
     *              which is used to create the DELETE statement
     * @param      PropelPDO $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *				if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
     public static function doDelete($values, PropelPDO $con = null)
     {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_WRITE);
        }

        if ($values instanceof Criteria) {
            // invalidate the cache for all objects of this type, since we have no
            // way of knowing (without running a query) what objects should be invalidated
            // from the cache based on this Criteria.
            LohnprofilPeer::clearInstancePool();
            // rename for clarity
            $criteria = clone $values;
        } elseif ($values instanceof Lohnprofil) { // it's a model object
            // invalidate the cache for this single object
            LohnprofilPeer::removeInstanceFromPool($values);
            // create criteria based on pk values
            $criteria = $values->buildPkeyCriteria();
        } else { // it's a primary key, or an array of pks
            $criteria = new Criteria(LohnprofilPeer::DATABASE_NAME);
            $criteria->add(LohnprofilPeer::ID, (array) $values, Criteria::IN);
            // invalidate the cache for this object(s)
            foreach ((array) $values as $singleval) {
                LohnprofilPeer::removeInstanceFromPool($singleval);
            }
        }

        // Set the correct dbName
        $criteria->setDbName(LohnprofilPeer::DATABASE_NAME);

        $affectedRows = 0; // initialize var to track total num of affected rows

        try {
            // use transaction because $criteria could contain info
            // for more than one table or we could emulating ON DELETE CASCADE, etc.
            $con->beginTransaction();

            $affectedRows += BasePeer::doDelete($criteria, $con);
            LohnprofilPeer::clearRelatedInstancePool();
            $con->commit();

            return $affectedRows;
        } catch (Exception $e) {
            $con->rollBack();
            throw $e;
        }
    }

    /**
     * Validates all modified columns of given Lohnprofil object.
     * If parameter $columns is either a single column name or an array of column names
     * than only those columns are validated.
     *
     * NOTICE: This does not apply to primary or foreign keys for now.
     *
     * @param Lohnprofil $obj The object to validate.
     * @param      mixed $cols Column name or array of column names.
     *
     * @return mixed TRUE if all columns are valid or the error message of the first invalid column.
     */
    public static function doValidate($obj, $cols = null)
    {
        $columns = array();

        if ($cols) {
            $dbMap = Propel::getDatabaseMap(LohnprofilPeer::DATABASE_NAME);
            $tableMap = $dbMap->getTable(LohnprofilPeer::TABLE_NAME);

            if (! is_array($cols)) {
                $cols = array($cols);
            }

            foreach ($cols as $colName) {
                if ($tableMap->hasColumn($colName)) {
                    $get = 'get' . $tableMap->getColumn($colName)->getPhpName();
                    $columns[$colName] = $obj->$get();
                }
            }
        } else {

        }

        return BasePeer::doValidate(LohnprofilPeer::DATABASE_NAME, LohnprofilPeer::TABLE_NAME, $columns);
    }

    /**
     * Retrieve a single object by pkey.
     *
     * @param int $pk the primary key.
     * @param      PropelPDO $con the connection to use
     * @return Lohnprofil
     */
    public static function retrieveByPK($pk, PropelPDO $con = null)
    {

        if (null !== ($obj = LohnprofilPeer::getInstanceFromPool((string) $pk))) {
            return $obj;
        }

        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $criteria = new Criteria(LohnprofilPeer::DATABASE_NAME);
        $criteria->add(LohnprofilPeer::ID, $pk);

        $v = LohnprofilPeer::doSelect($criteria, $con);

        return !empty($v) > 0 ? $v[0] : null;
    }

    /**
     * Retrieve multiple objects by pkey.
     *
     * @param      array $pks List of primary keys
     * @param      PropelPDO $con the connection to use
     * @return Lohnprofil[]
     * @throws PropelException Any exceptions caught during processing will be
     *		 rethrown wrapped into a PropelException.
     */
    public static function retrieveByPKs($pks, PropelPDO $con = null)
    {
        if ($con === null) {
            $con = Propel::getConnection(LohnprofilPeer::DATABASE_NAME, Propel::CONNECTION_READ);
        }

        $objs = null;
        if (empty($pks)) {
            $objs = array();
        } else {
            $criteria = new Criteria(LohnprofilPeer::DATABASE_NAME);
            $criteria->add(LohnprofilPeer::ID, $pks, Criteria::IN);
            $objs = LohnprofilPeer::doSelect($criteria, $con);
        }

        return $objs;
    }

} // BaseLohnprofilPeer

// This is the static code needed to register the TableMap for this table with the main Propel class.
//
BaseLohnprofilPeer::buildTableMap();

